/* config-schema.c generated by valac 0.56.17, the Vala compiler
 * generated from config-schema.vala, do not modify */

/*
 * Desktop Agnostic Library: Configuration Schema.
 *
 * Copyright (C) 2008, 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "desktop-agnostic-cfg.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <hashtable-gtype-key.c>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>
#include <libdesktop-agnostic/desktop-agnostic.h>
#include <desktop-agnostic-vfs.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_0_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_config_schema_properties[DESKTOP_AGNOSTIC_CONFIG_SCHEMA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

/**
   * Configuration schema error types.
   */
struct _DesktopAgnosticConfigSchemaPrivate {
	gchar* _filename;
	gchar* _app_name;
	GData* options;
	GHashTable* keys;
	GList* valid_metadata_keys;
	GData* metadata_options;
};

static gint DesktopAgnosticConfigSchema_private_offset;
static gpointer desktop_agnostic_config_schema_parent_class = NULL;
static GHashTable* desktop_agnostic_config_schema_type_registry;
static GHashTable* desktop_agnostic_config_schema_type_registry = NULL;
static GHashTable* desktop_agnostic_config_schema_name_registry;
static GHashTable* desktop_agnostic_config_schema_name_registry = NULL;
static GHashTable* desktop_agnostic_config_schema_common_metadata_keys;
static GHashTable* desktop_agnostic_config_schema_common_metadata_keys = NULL;

static void _g_object_unref0_ (gpointer var);
static void _g_free0_ (gpointer var);
static void _vala_GValue_free (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static void __g_list_free__g_free0_0_ (gpointer var);
static GValue* _g_value_dup (GValue* self);
static void desktop_agnostic_config_schema_parse (DesktopAgnosticConfigSchema* self,
                                           GError** error);
static void desktop_agnostic_config_schema_set_app_name (DesktopAgnosticConfigSchema* self,
                                                  const gchar* value);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void desktop_agnostic_config_schema_finalize (GObject * obj);
static GType desktop_agnostic_config_schema_get_type_once (void);
static void _vala_desktop_agnostic_config_schema_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_desktop_agnostic_config_schema_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

GQuark
desktop_agnostic_config_schema_error_quark (void)
{
#line 273 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return g_quark_from_static_string ("desktop-agnostic-config-schema-error-quark");
#line 116 "config-schema.c"
}

static GType
desktop_agnostic_config_schema_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE", "parse"}, {DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION, "DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION", "invalid-metadata-option"}, {DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_TYPE, "DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_TYPE", "invalid-metadata-type"}, {DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_TYPE, "DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_TYPE", "invalid-type"}, {DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_LIST_TYPE, "DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_LIST_TYPE", "invalid-list-type"}, {DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_NAME_EXISTS, "DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_NAME_EXISTS", "type-name-exists"}, {DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_GTYPE_EXISTS, "DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_GTYPE_EXISTS", "type-gtype-exists"}, {0, NULL, NULL}};
	GType desktop_agnostic_config_schema_error_type_id;
	desktop_agnostic_config_schema_error_type_id = g_enum_register_static ("DesktopAgnosticConfigSchemaError", values);
	return desktop_agnostic_config_schema_error_type_id;
}

GType
desktop_agnostic_config_schema_error_get_type (void)
{
	static volatile gsize desktop_agnostic_config_schema_error_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_config_schema_error_type_id__once)) {
		GType desktop_agnostic_config_schema_error_type_id;
		desktop_agnostic_config_schema_error_type_id = desktop_agnostic_config_schema_error_get_type_once ();
		g_once_init_leave (&desktop_agnostic_config_schema_error_type_id__once, desktop_agnostic_config_schema_error_type_id);
	}
	return desktop_agnostic_config_schema_error_type_id__once;
}

static inline gpointer
desktop_agnostic_config_schema_get_instance_private (DesktopAgnosticConfigSchema* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticConfigSchema_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 47 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 151 "config-schema.c"
}

static void
_g_free0_ (gpointer var)
{
#line 50 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	var = (g_free (var), NULL);
#line 159 "config-schema.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 167 "config-schema.c"
}

static void
__vala_GValue_free0_ (gpointer var)
{
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 175 "config-schema.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 183 "config-schema.c"
}

/**
     * Creates a new Schema object.
     * @param filename the name of the schema file to parse
     */
static void
__g_list_free__g_free0_0_ (gpointer var)
{
#line 195 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL));
#line 195 "config-schema.c"
}

static GValue*
_g_value_dup (GValue* self)
{
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 203 "config-schema.c"
}

static gpointer
__g_value_dup0 (gpointer self)
{
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return self ? _g_value_dup (self) : NULL;
#line 211 "config-schema.c"
}

DesktopAgnosticConfigSchema*
desktop_agnostic_config_schema_construct (GType object_type,
                                          const gchar* filename,
                                          GError** error)
{
	DesktopAgnosticConfigSchema * self = NULL;
	GHashTable* backend_metadata_keys = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	GList* _tmp4_;
	GHashTable* _tmp12_;
	GHashTable* _tmp13_;
	GList* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 191 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	self = (DesktopAgnosticConfigSchema*) g_object_new (object_type, "filename", filename, NULL);
#line 194 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_datalist_init (&self->priv->options);
#line 195 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = g_str_hash;
#line 195 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = g_str_equal;
#line 195 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, __g_list_free__g_free0_0_);
#line 195 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_hash_table_unref0 (self->priv->keys);
#line 195 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	self->priv->keys = _tmp2_;
#line 197 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(self->priv->valid_metadata_keys == NULL) ? NULL : (self->priv->valid_metadata_keys = (_g_list_free__g_free0_ (self->priv->valid_metadata_keys), NULL));
#line 197 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	self->priv->valid_metadata_keys = NULL;
#line 198 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_datalist_init (&self->priv->metadata_options);
#line 199 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp3_ = desktop_agnostic_config_schema_common_metadata_keys;
#line 199 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp4_ = g_hash_table_get_keys (_tmp3_);
#line 256 "config-schema.c"
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
#line 199 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		key_collection = _tmp4_;
#line 199 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 264 "config-schema.c"
			const gchar* key = NULL;
#line 199 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			key = (const gchar*) key_it->data;
#line 268 "config-schema.c"
			{
				const gchar* _tmp5_;
				gchar* _tmp6_;
				const gchar* _tmp7_;
				GHashTable* _tmp8_;
				const gchar* _tmp9_;
				gconstpointer _tmp10_;
				GValue* _tmp11_;
#line 201 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp5_ = key;
#line 201 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 201 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				self->priv->valid_metadata_keys = g_list_append (self->priv->valid_metadata_keys, _tmp6_);
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp7_ = key;
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp8_ = desktop_agnostic_config_schema_common_metadata_keys;
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp9_ = key;
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp10_ = g_hash_table_lookup (_tmp8_, _tmp9_);
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp11_ = __g_value_dup0 ((GValue*) _tmp10_);
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				g_datalist_set_data (&self->priv->metadata_options, _tmp7_, _tmp11_);
#line 295 "config-schema.c"
			}
		}
#line 199 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		(key_collection == NULL) ? NULL : (key_collection = (g_list_free (key_collection), NULL));
#line 300 "config-schema.c"
	}
#line 205 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp12_ = desktop_agnostic_config_backend_get_backend_metadata_keys ();
#line 205 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	backend_metadata_keys = _tmp12_;
#line 206 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp13_ = backend_metadata_keys;
#line 206 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp14_ = g_hash_table_get_keys (_tmp13_);
#line 310 "config-schema.c"
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
#line 206 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		key_collection = _tmp14_;
#line 206 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 318 "config-schema.c"
			const gchar* key = NULL;
#line 206 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			key = (const gchar*) key_it->data;
#line 322 "config-schema.c"
			{
				const gchar* _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				GHashTable* _tmp18_;
				const gchar* _tmp19_;
				gconstpointer _tmp20_;
				GValue* _tmp21_;
#line 208 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp15_ = key;
#line 208 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 208 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				self->priv->valid_metadata_keys = g_list_append (self->priv->valid_metadata_keys, _tmp16_);
#line 209 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp17_ = key;
#line 209 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp18_ = backend_metadata_keys;
#line 209 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp19_ = key;
#line 209 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp20_ = g_hash_table_lookup (_tmp18_, _tmp19_);
#line 209 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp21_ = __g_value_dup0 ((GValue*) _tmp20_);
#line 209 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				g_datalist_set_data (&self->priv->metadata_options, _tmp17_, _tmp21_);
#line 349 "config-schema.c"
			}
		}
#line 206 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		(key_collection == NULL) ? NULL : (key_collection = (g_list_free (key_collection), NULL));
#line 354 "config-schema.c"
	}
#line 212 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	desktop_agnostic_config_schema_parse (self, &_inner_error0_);
#line 212 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_propagate_error (error, _inner_error0_);
#line 212 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_g_object_unref0 (self);
#line 212 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		return NULL;
#line 366 "config-schema.c"
	}
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return self;
#line 370 "config-schema.c"
}

DesktopAgnosticConfigSchema*
desktop_agnostic_config_schema_new (const gchar* filename,
                                    GError** error)
{
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return desktop_agnostic_config_schema_construct (DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, filename, error);
#line 379 "config-schema.c"
}

/**
     * Parses the schema file for configuration options and metadata.
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 401 "config-schema.c"
}

static glong
string_pointer_to_offset (const gchar* self,
                          const gchar* pos)
{
	glong result;
#line 1326 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0L);
#line 1326 "glib-2.0.vapi"
	g_return_val_if_fail (pos != NULL, 0L);
#line 1327 "glib-2.0.vapi"
	result = (glong) (((gchar*) pos) - ((gchar*) self));
#line 1327 "glib-2.0.vapi"
	return result;
#line 417 "config-schema.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 440 "config-schema.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 449 "config-schema.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 468 "config-schema.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 472 "config-schema.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 478 "config-schema.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 488 "config-schema.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 496 "config-schema.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 500 "config-schema.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 506 "config-schema.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 516 "config-schema.c"
}

static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result;
#line 1322 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1323 "glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1323 "glib-2.0.vapi"
	return result;
#line 530 "config-schema.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return self ? g_object_ref (self) : NULL;
#line 538 "config-schema.c"
}

static void
desktop_agnostic_config_schema_parse (DesktopAgnosticConfigSchema* self,
                                      GError** error)
{
	const gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 217 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_if_fail (self != NULL);
#line 220 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = self->priv->_filename;
#line 220 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (_tmp0_ == NULL) {
#line 553 "config-schema.c"
		GError* _tmp1_;
#line 222 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp1_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "A (valid) schema file was not given.");
#line 222 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_inner_error0_ = _tmp1_;
#line 222 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_propagate_error (error, _inner_error0_);
#line 222 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		return;
#line 563 "config-schema.c"
	} else {
		GKeyFile* data = NULL;
		GKeyFile* _tmp2_;
		GKeyFile* _tmp3_;
		const gchar* _tmp4_;
		GKeyFile* _tmp5_;
		gsize _tmp6_ = 0;
		gchar** _tmp7_;
#line 226 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp2_ = g_key_file_new ();
#line 226 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		data = _tmp2_;
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp3_ = data;
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp4_ = self->priv->_filename;
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_key_file_load_from_file (_tmp3_, _tmp4_, G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error0_);
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_propagate_error (error, _inner_error0_);
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_g_key_file_unref0 (data);
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			return;
#line 590 "config-schema.c"
		}
#line 228 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp5_ = data;
#line 228 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp7_ = g_key_file_get_groups (_tmp5_, &_tmp6_);
#line 596 "config-schema.c"
		{
			gchar** group_collection = NULL;
			gint group_collection_length1 = 0;
			gint _group_collection_size_ = 0;
			gint group_it = 0;
#line 228 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			group_collection = _tmp7_;
#line 228 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			group_collection_length1 = _tmp6_;
#line 228 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			for (group_it = 0; group_it < group_collection_length1; group_it = group_it + 1) {
#line 608 "config-schema.c"
				const gchar* group = NULL;
#line 228 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				group = group_collection[group_it];
#line 612 "config-schema.c"
				{
					const gchar* _tmp8_;
#line 230 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp8_ = group;
#line 230 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					if (string_contains (_tmp8_, "/")) {
#line 619 "config-schema.c"
						const gchar* last_slash = NULL;
						const gchar* _tmp9_;
						const gchar* _tmp10_;
						gint _tmp11_;
						gint _tmp12_;
						const gchar* _tmp13_;
						glong offset = 0L;
						const gchar* _tmp14_;
						const gchar* _tmp15_;
						gchar* option_group = NULL;
						const gchar* _tmp16_;
						gchar* _tmp17_;
						const gchar* option_key = NULL;
						const gchar* _tmp18_;
						const gchar* _tmp19_;
						GList* list = NULL;
						GHashTable* _tmp20_;
						const gchar* _tmp21_;
						gconstpointer _tmp22_;
						GList* _tmp23_;
						DesktopAgnosticConfigSchemaOption* option = NULL;
						const gchar* _tmp37_;
						const gchar* _tmp38_;
						DesktopAgnosticConfigSchemaOption* _tmp39_;
						const gchar* _tmp40_;
						DesktopAgnosticConfigSchemaOption* _tmp41_;
						DesktopAgnosticConfigSchemaOption* _tmp42_;
#line 233 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp9_ = group;
#line 233 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp10_ = group;
#line 233 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp11_ = strlen (_tmp10_);
#line 233 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp12_ = _tmp11_;
#line 233 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp13_ = g_utf8_strrchr (_tmp9_, (gssize) _tmp12_, (gunichar) '/');
#line 233 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						last_slash = _tmp13_;
#line 234 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp14_ = group;
#line 234 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp15_ = last_slash;
#line 234 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						offset = string_pointer_to_offset (_tmp14_, _tmp15_);
#line 235 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp16_ = group;
#line 235 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp17_ = string_substring (_tmp16_, (glong) 0, offset);
#line 235 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						option_group = _tmp17_;
#line 236 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp18_ = group;
#line 236 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp19_ = string_offset (_tmp18_, offset + 1);
#line 236 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						option_key = _tmp19_;
#line 237 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp20_ = self->priv->keys;
#line 237 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp21_ = option_group;
#line 237 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp22_ = g_hash_table_lookup (_tmp20_, _tmp21_);
#line 237 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						list = (GList*) _tmp22_;
#line 238 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp23_ = list;
#line 238 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						if (_tmp23_ == NULL) {
#line 689 "config-schema.c"
							GList* key_list = NULL;
							const gchar* _tmp24_;
							gchar* _tmp25_;
							GHashTable* _tmp26_;
							const gchar* _tmp27_;
							gchar* _tmp28_;
							GList* _tmp29_;
#line 240 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							key_list = NULL;
#line 241 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp24_ = option_key;
#line 241 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp25_ = g_strdup (_tmp24_);
#line 241 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							key_list = g_list_append (key_list, _tmp25_);
#line 242 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp26_ = self->priv->keys;
#line 242 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp27_ = option_group;
#line 242 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp28_ = g_strdup (_tmp27_);
#line 242 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp29_ = key_list;
#line 242 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							key_list = NULL;
#line 242 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							g_hash_table_insert (_tmp26_, _tmp28_, _tmp29_);
#line 238 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							(key_list == NULL) ? NULL : (key_list = (_g_list_free__g_free0_ (key_list), NULL));
#line 719 "config-schema.c"
						} else {
							const gchar* _tmp30_;
							const gchar* _tmp31_;
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp30_ = option_group;
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp31_ = option_key;
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							if (!desktop_agnostic_config_schema_exists (self, _tmp30_, _tmp31_)) {
#line 729 "config-schema.c"
								const gchar* _tmp32_;
								gchar* _tmp33_;
#line 246 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_tmp32_ = option_key;
#line 246 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_tmp33_ = g_strdup (_tmp32_);
#line 246 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								list = g_list_append (list, _tmp33_);
#line 738 "config-schema.c"
							} else {
								const gchar* _tmp34_;
								const gchar* _tmp35_;
								GError* _tmp36_;
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_tmp34_ = option_group;
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_tmp35_ = option_key;
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_tmp36_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "Duplicate key found in '%s': %s", _tmp34_, _tmp35_);
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_inner_error0_ = _tmp36_;
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								g_propagate_error (error, _inner_error0_);
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_g_free0 (option_group);
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_g_key_file_unref0 (data);
#line 250 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								return;
#line 761 "config-schema.c"
							}
						}
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp37_ = option_group;
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp38_ = option_key;
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp39_ = desktop_agnostic_config_schema_option_new (&data, _tmp37_, _tmp38_, &_inner_error0_);
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						option = _tmp39_;
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							g_propagate_error (error, _inner_error0_);
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_g_free0 (option_group);
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_g_key_file_unref0 (data);
#line 254 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							return;
#line 784 "config-schema.c"
						}
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp40_ = group;
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp41_ = option;
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp42_ = _g_object_ref0 (_tmp41_);
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						g_datalist_set_data (&self->priv->options, _tmp40_, _tmp42_);
#line 230 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_g_object_unref0 (option);
#line 230 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_g_free0 (option_group);
#line 798 "config-schema.c"
					} else {
						const gchar* _tmp43_;
#line 258 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp43_ = group;
#line 258 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						if (g_strcmp0 (_tmp43_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT) == 0) {
#line 805 "config-schema.c"
							gchar** _tmp44_ = NULL;
							GKeyFile* _tmp45_;
							const gchar* _tmp46_;
							gsize _tmp47_ = 0;
							gchar** _tmp48_;
							gint _tmp44__length1;
							gint __tmp44__size_;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp45_ = data;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp46_ = group;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp48_ = g_key_file_get_keys (_tmp45_, _tmp46_, &_tmp47_, &_inner_error0_);
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp44_ = _tmp48_;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp44__length1 = _tmp47_;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							__tmp44__size_ = _tmp44__length1;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								g_propagate_error (error, _inner_error0_);
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_g_key_file_unref0 (data);
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								return;
#line 835 "config-schema.c"
							}
							{
								gchar** key_collection = NULL;
								gint key_collection_length1 = 0;
								gint _key_collection_size_ = 0;
								gint key_it = 0;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								key_collection = _tmp44_;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								key_collection_length1 = _tmp44__length1;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 848 "config-schema.c"
									const gchar* key = NULL;
#line 261 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									key = key_collection[key_it];
#line 852 "config-schema.c"
									{
										GList* _tmp49_;
										const gchar* _tmp50_;
										GCompareFunc _tmp51_;
										GList* _tmp52_;
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
										_tmp49_ = self->priv->valid_metadata_keys;
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
										_tmp50_ = key;
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
										_tmp51_ = ((GCompareFunc) g_strcmp0);
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
										_tmp52_ = g_list_find_custom (_tmp49_, _tmp50_, (GCompareFunc) _tmp51_);
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
										if (_tmp52_ == NULL) {
#line 868 "config-schema.c"
											const gchar* _tmp53_;
											GError* _tmp54_;
#line 265 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp53_ = key;
#line 265 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp54_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION, "The option '%s' is not a registered metadata option.", _tmp53_);
#line 265 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_inner_error0_ = _tmp54_;
#line 265 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											g_propagate_error (error, _inner_error0_);
#line 265 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 265 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 265 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_g_key_file_unref0 (data);
#line 265 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											return;
#line 887 "config-schema.c"
										} else {
											GValue cur_val = {0};
											GValue new_val = {0};
											GType cur_val_type = 0UL;
											const gchar* _tmp55_;
											gconstpointer _tmp56_;
											GValue _tmp57_;
											GValue _tmp58_ = {0};
											GValue _tmp59_ = {0};
											const gchar* _tmp78_;
											GValue _tmp79_;
											GValue _tmp80_;
											GValue* _tmp81_;
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp55_ = key;
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp56_ = g_datalist_get_data (&self->priv->metadata_options, _tmp55_);
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp57_ = *((GValue*) _tmp56_);
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											if (G_IS_VALUE (&_tmp57_)) {
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												g_value_init (&_tmp58_, G_VALUE_TYPE (&_tmp57_));
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												g_value_copy (&_tmp57_, &_tmp58_);
#line 913 "config-schema.c"
											} else {
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_tmp58_ = _tmp57_;
#line 917 "config-schema.c"
											}
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
#line 272 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											cur_val = _tmp58_;
#line 273 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											cur_val_type = G_VALUE_TYPE (&cur_val);
#line 274 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											g_value_init (&_tmp59_, cur_val_type);
#line 274 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
#line 274 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											new_val = _tmp59_;
#line 275 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											if (cur_val_type == G_TYPE_BOOLEAN) {
#line 933 "config-schema.c"
												gboolean _tmp60_ = FALSE;
												GKeyFile* _tmp61_;
												const gchar* _tmp62_;
												const gchar* _tmp63_;
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_tmp61_ = data;
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_tmp62_ = group;
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_tmp63_ = key;
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_tmp60_ = g_key_file_get_boolean (_tmp61_, _tmp62_, _tmp63_, &_inner_error0_);
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													g_propagate_error (error, _inner_error0_);
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													_g_key_file_unref0 (data);
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													return;
#line 962 "config-schema.c"
												}
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												g_value_set_boolean (&new_val, _tmp60_);
#line 966 "config-schema.c"
											} else {
#line 279 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												if (cur_val_type == G_TYPE_INT) {
#line 970 "config-schema.c"
													gint _tmp64_ = 0;
													GKeyFile* _tmp65_;
													const gchar* _tmp66_;
													const gchar* _tmp67_;
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													_tmp65_ = data;
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													_tmp66_ = group;
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													_tmp67_ = key;
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													_tmp64_ = g_key_file_get_integer (_tmp65_, _tmp66_, _tmp67_, &_inner_error0_);
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														g_propagate_error (error, _inner_error0_);
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														_g_key_file_unref0 (data);
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														return;
#line 999 "config-schema.c"
													}
#line 281 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													g_value_set_int (&new_val, _tmp64_);
#line 1003 "config-schema.c"
												} else {
#line 283 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
													if (cur_val_type == G_TYPE_FLOAT) {
#line 1007 "config-schema.c"
														gdouble _tmp68_ = 0.0;
														GKeyFile* _tmp69_;
														const gchar* _tmp70_;
														const gchar* _tmp71_;
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														_tmp69_ = data;
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														_tmp70_ = group;
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														_tmp71_ = key;
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														_tmp68_ = g_key_file_get_double (_tmp69_, _tmp70_, _tmp71_, &_inner_error0_);
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															g_propagate_error (error, _inner_error0_);
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_g_key_file_unref0 (data);
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															return;
#line 1036 "config-schema.c"
														}
#line 285 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														g_value_set_float (&new_val, (gfloat) _tmp68_);
#line 1040 "config-schema.c"
													} else {
#line 287 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
														if (cur_val_type == G_TYPE_STRING) {
#line 1044 "config-schema.c"
															gchar* _tmp72_ = NULL;
															GKeyFile* _tmp73_;
															const gchar* _tmp74_;
															const gchar* _tmp75_;
															gchar* _tmp76_;
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_tmp73_ = data;
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_tmp74_ = group;
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_tmp75_ = key;
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_tmp76_ = g_key_file_get_string (_tmp73_, _tmp74_, _tmp75_, &_inner_error0_);
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_tmp72_ = _tmp76_;
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
																g_propagate_error (error, _inner_error0_);
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
																G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
																G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
																_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
																group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
																_g_key_file_unref0 (data);
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
																return;
#line 1076 "config-schema.c"
															}
#line 289 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															g_value_set_string (&new_val, _tmp72_);
#line 287 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_g_free0 (_tmp72_);
#line 1082 "config-schema.c"
														} else {
															GError* _tmp77_;
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_tmp77_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_TYPE, "The metadata option type can only be a simple type.");
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_inner_error0_ = _tmp77_;
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															g_propagate_error (error, _inner_error0_);
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															_g_key_file_unref0 (data);
#line 293 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
															return;
#line 1103 "config-schema.c"
														}
													}
												}
											}
#line 295 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp78_ = key;
#line 295 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp79_ = new_val;
#line 295 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp80_ = _tmp79_;
#line 295 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp81_ = __g_value_dup0 (&_tmp80_);
#line 295 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											g_datalist_set_data (&self->priv->metadata_options, _tmp78_, _tmp81_);
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
#line 1122 "config-schema.c"
										}
									}
								}
							}
#line 258 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 1129 "config-schema.c"
						} else {
							const gchar* _tmp82_;
							const gchar* _tmp83_;
							GError* _tmp84_;
#line 301 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp82_ = self->priv->_filename;
#line 301 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp83_ = group;
#line 301 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_tmp84_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "Invalid section in schema ('%s'), there is no group name: %s", _tmp82_, _tmp83_);
#line 301 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_inner_error0_ = _tmp84_;
#line 301 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							g_propagate_error (error, _inner_error0_);
#line 301 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 301 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							_g_key_file_unref0 (data);
#line 301 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							return;
#line 1150 "config-schema.c"
						}
					}
				}
			}
#line 228 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1157 "config-schema.c"
		}
#line 220 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_g_key_file_unref0 (data);
#line 1161 "config-schema.c"
	}
}

/**
     * Retrieves the configuration groups in the schema.
     * @return a list of zero or more groups
     */
GList*
desktop_agnostic_config_schema_get_groups (DesktopAgnosticConfigSchema* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GList* result;
#line 311 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 314 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = self->priv->keys;
#line 314 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 314 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	result = _tmp1_;
#line 314 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return result;
#line 1185 "config-schema.c"
}

/**
     * Retrieves the configuration keys for a specified group in the schema.
     * @param group the group name to search for keys associated with it
     * @return a list of zero or more keys
     */
GList*
desktop_agnostic_config_schema_get_keys (DesktopAgnosticConfigSchema* self,
                                         const gchar* group)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GList* result;
#line 321 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 321 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 324 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = self->priv->keys;
#line 324 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, group);
#line 324 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	result = (GList*) _tmp1_;
#line 324 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return result;
#line 1212 "config-schema.c"
}

/**
     * Determines if a specified group/key exists in the schema.
     * @param group the group that the key is associated with
     * @param key the configuration key to determine if it exists
     * @return whether the group/key exists
     */
gboolean
desktop_agnostic_config_schema_exists (DesktopAgnosticConfigSchema* self,
                                       const gchar* group,
                                       const gchar* key)
{
	GList* group_keys = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
	GList* _tmp3_;
	gboolean result;
#line 332 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 332 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 332 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 335 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = self->priv->keys;
#line 335 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, group);
#line 335 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	group_keys = (GList*) _tmp1_;
#line 336 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp3_ = group_keys;
#line 336 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (_tmp3_ != NULL) {
#line 1248 "config-schema.c"
		GList* _tmp4_;
		GCompareFunc _tmp5_;
		GList* _tmp6_;
#line 337 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp4_ = group_keys;
#line 337 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp5_ = ((GCompareFunc) g_strcmp0);
#line 337 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp6_ = g_list_find_custom (_tmp4_, key, (GCompareFunc) _tmp5_);
#line 337 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp2_ = _tmp6_ != NULL;
#line 1260 "config-schema.c"
	} else {
#line 336 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp2_ = FALSE;
#line 1264 "config-schema.c"
	}
#line 336 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	result = _tmp2_;
#line 336 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return result;
#line 1270 "config-schema.c"
}

/**
     * Retrieves the metadata associated with a specific group/key.
     * @param group the group that the key is associated with
     * @param key the configuration key to retrieve metadata from
     * @return an object which contains the option metadata
     */
DesktopAgnosticConfigSchemaOption*
desktop_agnostic_config_schema_get_option (DesktopAgnosticConfigSchema* self,
                                           const gchar* group,
                                           const gchar* key)
{
	gchar* full_key = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gconstpointer _tmp4_;
	DesktopAgnosticConfigSchemaOption* result;
#line 345 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 345 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 345 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 348 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = g_strconcat (group, "/", NULL);
#line 348 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = _tmp0_;
#line 348 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp2_ = g_strconcat (_tmp1_, key, NULL);
#line 348 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp3_ = _tmp2_;
#line 348 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_free0 (_tmp1_);
#line 348 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	full_key = _tmp3_;
#line 349 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp4_ = g_datalist_get_data (&self->priv->options, full_key);
#line 349 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	result = (DesktopAgnosticConfigSchemaOption*) _tmp4_;
#line 349 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_free0 (full_key);
#line 349 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return result;
#line 1317 "config-schema.c"
}

/**
     * Retrieves the value of the specified metadata option.
     * @throws SchemaError if the option named specified is not registered
     */
GValue*
desktop_agnostic_config_schema_get_metadata_option (DesktopAgnosticConfigSchema* self,
                                                    const gchar* name,
                                                    GError** error)
{
	GList* _tmp0_;
	GCompareFunc _tmp1_;
	GList* _tmp2_;
	GError* _inner_error0_ = NULL;
	GValue* result;
#line 355 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 355 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 358 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = self->priv->valid_metadata_keys;
#line 358 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = ((GCompareFunc) g_strcmp0);
#line 358 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp2_ = g_list_find_custom (_tmp0_, name, (GCompareFunc) _tmp1_);
#line 358 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (_tmp2_ == NULL) {
#line 1346 "config-schema.c"
		GError* _tmp3_;
#line 360 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp3_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION, "The option '%s' is not a registered metadata option.", name);
#line 360 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_inner_error0_ = _tmp3_;
#line 360 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
#line 360 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_propagate_error (error, _inner_error0_);
#line 360 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			return NULL;
#line 1358 "config-schema.c"
		} else {
#line 360 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 360 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_clear_error (&_inner_error0_);
#line 360 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			return NULL;
#line 1366 "config-schema.c"
		}
	} else {
		gconstpointer _tmp4_;
		GValue* _tmp5_;
#line 364 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp4_ = g_datalist_get_data (&self->priv->metadata_options, name);
#line 364 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp5_ = __g_value_dup0 ((GValue*) _tmp4_);
#line 364 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		result = _tmp5_;
#line 364 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		return result;
#line 1379 "config-schema.c"
	}
}

/**
     * Registers a configuration schema type with the class. This is usually
     * not called manually - the class loads all of the configuration schema
     * type modules that it can find when the class is first instantiated.
     */
void
desktop_agnostic_config_schema_register_type (DesktopAgnosticConfigSchemaType* st,
                                              GError** error)
{
	GHashTable* _tmp0_;
	GType _tmp1_;
	GType _tmp2_;
	gconstpointer _tmp3_;
	GError* _inner_error0_ = NULL;
#line 372 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_if_fail (st != NULL);
#line 375 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = desktop_agnostic_config_schema_type_registry;
#line 375 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = desktop_agnostic_config_schema_type_get_schema_type (st);
#line 375 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp2_ = _tmp1_;
#line 375 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp3_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) _tmp2_));
#line 375 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (((DesktopAgnosticConfigSchemaType*) _tmp3_) != NULL) {
#line 1409 "config-schema.c"
		GError* _tmp4_;
#line 377 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp4_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_GTYPE_EXISTS, "The GType associated with the SchemaType is already registered.");
#line 377 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_inner_error0_ = _tmp4_;
#line 377 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
#line 377 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_propagate_error (error, _inner_error0_);
#line 377 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			return;
#line 1421 "config-schema.c"
		} else {
#line 377 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 377 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_clear_error (&_inner_error0_);
#line 377 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			return;
#line 1429 "config-schema.c"
		}
	} else {
		GHashTable* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gconstpointer _tmp9_;
		gboolean _tmp10_;
#line 379 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp5_ = desktop_agnostic_config_schema_name_registry;
#line 379 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp6_ = desktop_agnostic_config_schema_type_get_name (st);
#line 379 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp7_ = _tmp6_;
#line 379 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp8_ = _tmp7_;
#line 379 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp9_ = g_hash_table_lookup (_tmp5_, _tmp8_);
#line 379 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp10_ = ((DesktopAgnosticConfigSchemaType*) _tmp9_) != NULL;
#line 379 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_g_free0 (_tmp8_);
#line 379 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		if (_tmp10_) {
#line 1454 "config-schema.c"
			GError* _tmp11_;
#line 381 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp11_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_NAME_EXISTS, "The name associated with the SchemaType is already registered.");
#line 381 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_inner_error0_ = _tmp11_;
#line 381 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
#line 381 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				g_propagate_error (error, _inner_error0_);
#line 381 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				return;
#line 1466 "config-schema.c"
			} else {
#line 381 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 381 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				g_clear_error (&_inner_error0_);
#line 381 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				return;
#line 1474 "config-schema.c"
			}
		} else {
			GHashTable* _tmp12_;
			GType _tmp13_;
			GType _tmp14_;
			DesktopAgnosticConfigSchemaType* _tmp15_;
			GHashTable* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			DesktopAgnosticConfigSchemaType* _tmp19_;
#line 385 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp12_ = desktop_agnostic_config_schema_type_registry;
#line 385 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp13_ = desktop_agnostic_config_schema_type_get_schema_type (st);
#line 385 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp14_ = _tmp13_;
#line 385 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp15_ = _g_object_ref0 (st);
#line 385 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_hash_table_insert (_tmp12_, (gpointer) ((gintptr) _tmp14_), _tmp15_);
#line 386 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp16_ = desktop_agnostic_config_schema_name_registry;
#line 386 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp17_ = desktop_agnostic_config_schema_type_get_name (st);
#line 386 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp18_ = _tmp17_;
#line 386 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			_tmp19_ = _g_object_ref0 (st);
#line 386 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			g_hash_table_insert (_tmp16_, _tmp18_, _tmp19_);
#line 1505 "config-schema.c"
		}
	}
}

/**
     * Looks for a registered SchemaType by its GType.
     */
DesktopAgnosticConfigSchemaType*
desktop_agnostic_config_schema_find_type (GType type)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	DesktopAgnosticConfigSchemaType* result;
#line 395 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = desktop_agnostic_config_schema_type_registry;
#line 395 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) type));
#line 395 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	result = (DesktopAgnosticConfigSchemaType*) _tmp1_;
#line 395 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return result;
#line 1527 "config-schema.c"
}

/**
     * Looks for a registered SchemaType by its declared name.
     */
DesktopAgnosticConfigSchemaType*
desktop_agnostic_config_schema_find_type_by_name (const gchar* name)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	DesktopAgnosticConfigSchemaType* result;
#line 400 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 403 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = desktop_agnostic_config_schema_name_registry;
#line 403 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, name);
#line 403 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	result = (DesktopAgnosticConfigSchemaType*) _tmp1_;
#line 403 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return result;
#line 1549 "config-schema.c"
}

static void
desktop_agnostic_config_schema_set_filename (DesktopAgnosticConfigSchema* self,
                                             const gchar* value)
{
	gchar* basename = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 160 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_if_fail (self != NULL);
#line 162 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	basename = NULL;
#line 164 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (!g_str_has_suffix (value, ".schema-ini")) {
#line 166 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_critical ("config-schema.vala:166: Schema files MUST have the extension '.schema-" \
"ini'.");
#line 167 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_g_free0 (basename);
#line 167 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		return;
#line 1577 "config-schema.c"
	}
#line 169 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (!g_file_test (value, G_FILE_TEST_EXISTS)) {
#line 171 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_critical ("config-schema.vala:171: The file '%s' could not be found.", value);
#line 172 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_g_free0 (basename);
#line 172 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		return;
#line 1587 "config-schema.c"
	}
#line 174 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = g_strdup (value);
#line 174 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_free0 (self->priv->_filename);
#line 174 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	self->priv->_filename = _tmp0_;
#line 175 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = g_path_get_basename (value);
#line 175 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_free0 (basename);
#line 175 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	basename = _tmp1_;
#line 176 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp2_ = basename;
#line 176 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp3_ = basename;
#line 176 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp4_ = strlen (_tmp3_);
#line 176 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp5_ = _tmp4_;
#line 176 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp6_ = string_substring (_tmp2_, (glong) 0, (glong) (_tmp5_ - 11));
#line 176 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp7_ = _tmp6_;
#line 176 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	desktop_agnostic_config_schema_set_app_name (self, _tmp7_);
#line 176 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_free0 (_tmp7_);
#line 160 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_free0 (basename);
#line 160 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_config_schema_properties[DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME_PROPERTY]);
#line 1621 "config-schema.c"
}

const gchar*
desktop_agnostic_config_schema_get_app_name (DesktopAgnosticConfigSchema* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = self->priv->_app_name;
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	result = _tmp0_;
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	return result;
#line 1637 "config-schema.c"
}

static void
desktop_agnostic_config_schema_set_app_name (DesktopAgnosticConfigSchema* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_return_if_fail (self != NULL);
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	old_value = desktop_agnostic_config_schema_get_app_name (self);
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1651 "config-schema.c"
		gchar* _tmp0_;
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp0_ = g_strdup (value);
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_g_free0 (self->priv->_app_name);
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		self->priv->_app_name = _tmp0_;
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_config_schema_properties[DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME_PROPERTY]);
#line 1661 "config-schema.c"
	}
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 1670 "config-schema.c"
}

static void
desktop_agnostic_config_schema_class_init (DesktopAgnosticConfigSchemaClass * klass,
                                           gpointer klass_data)
{
	GHashTable* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GHashFunc _tmp4_;
	GEqualFunc _tmp5_;
	GHashTable* _tmp6_;
	GList* type_modules = NULL;
	gchar** paths = NULL;
	gint paths_length1 = 0;
	gint _paths_size_ = 0;
	GSList* search_paths = NULL;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar* _tmp13_;
	GSList* _tmp14_;
	GValue val = {0};
	GValue _tmp47_ = {0};
	GHashTable* _tmp48_;
	gchar* _tmp49_;
	GValue _tmp50_;
	GValue _tmp51_;
	GValue* _tmp52_;
	GError* _inner_error0_ = NULL;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	desktop_agnostic_config_schema_parent_class = g_type_class_peek_parent (klass);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticConfigSchema_private_offset);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_config_schema_get_property;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_config_schema_set_property;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_config_schema_finalize;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME_PROPERTY, desktop_agnostic_config_schema_properties[DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME_PROPERTY, desktop_agnostic_config_schema_properties[DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "Application name", "The name of the application associated with the schema", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 47 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp0_ = g_hash_table_new_full ((GHashFunc) desktop_agnostic_config_gtype_hash, (GEqualFunc) desktop_agnostic_config_gtype_equal, NULL, _g_object_unref0_);
#line 47 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	desktop_agnostic_config_schema_type_registry = _tmp0_;
#line 50 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp1_ = g_str_hash;
#line 50 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp2_ = g_str_equal;
#line 50 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
#line 50 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	desktop_agnostic_config_schema_name_registry = _tmp3_;
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp4_ = g_str_hash;
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp5_ = g_str_equal;
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp6_ = g_hash_table_new_full (_tmp4_, _tmp5_, _g_free0_, __vala_GValue_free0_);
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	desktop_agnostic_config_schema_common_metadata_keys = _tmp6_;
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(type_modules == NULL) ? NULL : (type_modules = (_g_list_free__g_free0_ (type_modules), NULL));
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	type_modules = NULL;
#line 63 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	desktop_agnostic_module_loader_get_default ();
#line 1743 "config-schema.c"
	{
#line 67 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		desktop_agnostic_config_get_type (&_inner_error0_);
#line 67 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1749 "config-schema.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_clear_error (&_inner_error0_);
#line 1758 "config-schema.c"
	}
	__finally0:
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		(search_paths == NULL) ? NULL : (search_paths = (_g_slist_free__g_free0_ (search_paths), NULL));
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		(type_modules == NULL) ? NULL : (type_modules = (_g_list_free__g_free0_ (type_modules), NULL));
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_clear_error (&_inner_error0_);
#line 1773 "config-schema.c"
	}
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp8_ = desktop_agnostic_module_loader_get_search_paths (&_tmp7_);
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	paths = _tmp8_;
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	paths_length1 = _tmp7_;
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_paths_size_ = paths_length1;
#line 76 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(search_paths == NULL) ? NULL : (search_paths = (_g_slist_free__g_free0_ (search_paths), NULL));
#line 76 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	search_paths = NULL;
#line 77 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp9_ = paths;
#line 77 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp9__length1 = paths_length1;
#line 1793 "config-schema.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 77 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		path_collection = _tmp9_;
#line 77 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		path_collection_length1 = _tmp9__length1;
#line 77 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
#line 1805 "config-schema.c"
			const gchar* path = NULL;
#line 77 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			path = path_collection[path_it];
#line 1809 "config-schema.c"
			{
				const gchar* _tmp10_;
#line 79 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp10_ = path;
#line 79 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				if (_tmp10_ != NULL) {
#line 1816 "config-schema.c"
					const gchar* _tmp11_;
					gchar* _tmp12_;
#line 81 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp11_ = path;
#line 81 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp12_ = g_strdup (_tmp11_);
#line 81 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					search_paths = g_slist_append (search_paths, _tmp12_);
#line 1825 "config-schema.c"
				}
			}
		}
	}
#line 84 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp13_ = g_get_current_dir ();
#line 84 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	search_paths = g_slist_append (search_paths, _tmp13_);
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp14_ = search_paths;
#line 1836 "config-schema.c"
	{
		GSList* path_collection = NULL;
		GSList* path_it = NULL;
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		path_collection = _tmp14_;
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 1844 "config-schema.c"
			const gchar* path = NULL;
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			path = (const gchar*) path_it->data;
#line 1848 "config-schema.c"
			{
				const gchar* _tmp15_;
				gchar* module_glob = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp15_ = path;
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				if (!g_file_test (_tmp15_, G_FILE_TEST_IS_DIR)) {
#line 90 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					continue;
#line 1860 "config-schema.c"
				}
#line 92 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp16_ = path;
#line 92 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_tmp17_ = g_build_filename (_tmp16_, "libda-cfg-type-*", NULL);
#line 92 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				module_glob = _tmp17_;
#line 1868 "config-schema.c"
				{
					DesktopAgnosticVFSGlob* found_modules = NULL;
					gchar** modules_paths = NULL;
					gint modules_paths_length1 = 0;
					gint _modules_paths_size_ = 0;
					DesktopAgnosticVFSGlob* _tmp18_ = NULL;
					const gchar* _tmp19_;
					DesktopAgnosticVFSGlob* _tmp20_;
					DesktopAgnosticVFSGlob* _tmp21_;
					DesktopAgnosticVFSGlob* _tmp22_;
					gint _tmp23_ = 0;
					gchar** _tmp24_;
					gchar** _tmp25_;
					gint _tmp25__length1;
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp19_ = module_glob;
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp20_ = desktop_agnostic_vfs_glob_execute (_tmp19_, &_inner_error0_);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp18_ = _tmp20_;
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_g_object_unref0 (found_modules);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 1895 "config-schema.c"
							goto __catch1_desktop_agnostic_vfs_glob_error;
						}
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_g_free0 (module_glob);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						(search_paths == NULL) ? NULL : (search_paths = (_g_slist_free__g_free0_ (search_paths), NULL));
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						(type_modules == NULL) ? NULL : (type_modules = (_g_list_free__g_free0_ (type_modules), NULL));
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						g_clear_error (&_inner_error0_);
#line 1910 "config-schema.c"
					}
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp21_ = _tmp18_;
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp18_ = NULL;
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_g_object_unref0 (found_modules);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					found_modules = _tmp21_;
#line 99 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp22_ = found_modules;
#line 99 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp24_ = desktop_agnostic_vfs_glob_get_paths (_tmp22_, &_tmp23_);
#line 99 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					modules_paths = _tmp24_;
#line 99 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					modules_paths_length1 = _tmp23_;
#line 99 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_modules_paths_size_ = modules_paths_length1;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp25_ = modules_paths;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp25__length1 = modules_paths_length1;
#line 1934 "config-schema.c"
					{
						gchar** module_collection = NULL;
						gint module_collection_length1 = 0;
						gint _module_collection_size_ = 0;
						gint module_it = 0;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						module_collection = _tmp25_;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						module_collection_length1 = _tmp25__length1;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						for (module_it = 0; module_it < module_collection_length1; module_it = module_it + 1) {
#line 1946 "config-schema.c"
							const gchar* module = NULL;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
							module = module_collection[module_it];
#line 1950 "config-schema.c"
							{
								GList* _tmp26_;
								const gchar* _tmp27_;
								GList* _tmp28_;
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_tmp26_ = type_modules;
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_tmp27_ = module;
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								_tmp28_ = g_list_find (_tmp26_, _tmp27_);
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
								if (_tmp28_ == NULL) {
#line 1963 "config-schema.c"
									GType type = 0UL;
									DesktopAgnosticModuleLoader* loader = NULL;
									DesktopAgnosticModuleLoader* _tmp29_;
									DesktopAgnosticModuleLoader* _tmp30_;
									const gchar* _tmp31_;
									gchar* _tmp32_;
									gchar* _tmp33_;
									const gchar* _tmp34_;
#line 106 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									_tmp29_ = desktop_agnostic_module_loader_get_default ();
#line 106 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									loader = _tmp29_;
#line 107 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									_tmp30_ = loader;
#line 107 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									_tmp31_ = module;
#line 107 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									_tmp32_ = g_path_get_basename (_tmp31_);
#line 107 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									_tmp33_ = _tmp32_;
#line 107 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									_tmp34_ = module;
#line 107 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									type = desktop_agnostic_module_loader_load_from_path (_tmp30_, _tmp33_, _tmp34_);
#line 107 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									_g_free0 (_tmp33_);
#line 111 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
									if (type != G_TYPE_INVALID) {
#line 1992 "config-schema.c"
										{
											GObject* obj = NULL;
											GObject* _tmp35_;
											GObject* _tmp36_;
											GObject* _tmp37_;
											DesktopAgnosticConfigSchemaType* _tmp38_;
											const gchar* _tmp39_;
											gchar* _tmp40_;
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp35_ = g_object_new (type, NULL);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp36_ = G_IS_INITIALLY_UNOWNED (_tmp35_) ? g_object_ref_sink (_tmp35_) : _tmp35_;
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											obj = _tmp36_;
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp37_ = obj;
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											obj = NULL;
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp38_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE, DesktopAgnosticConfigSchemaType);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											desktop_agnostic_config_schema_register_type (_tmp38_, &_inner_error0_);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_g_object_unref0 (_tmp38_);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_g_object_unref0 (obj);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
#line 2023 "config-schema.c"
													goto __catch2_desktop_agnostic_config_schema_error;
												}
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_g_object_unref0 (_tmp18_);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_g_object_unref0 (found_modules);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												_g_free0 (module_glob);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												(search_paths == NULL) ? NULL : (search_paths = (_g_slist_free__g_free0_ (search_paths), NULL));
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												(type_modules == NULL) ? NULL : (type_modules = (_g_list_free__g_free0_ (type_modules), NULL));
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
												g_clear_error (&_inner_error0_);
#line 2042 "config-schema.c"
											}
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp39_ = module;
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp40_ = g_strdup (_tmp39_);
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											type_modules = g_list_append (type_modules, _tmp40_);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_g_object_unref0 (obj);
#line 2052 "config-schema.c"
										}
										goto __finally2;
										__catch2_desktop_agnostic_config_schema_error:
										{
											GError* err = NULL;
											GError* _tmp41_;
											const gchar* _tmp42_;
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											err = _inner_error0_;
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_inner_error0_ = NULL;
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp41_ = err;
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_tmp42_ = _tmp41_->message;
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											g_warning ("config-schema.vala:120: Schema error: %s", _tmp42_);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_g_error_free0 (err);
#line 2072 "config-schema.c"
										}
										__finally2:
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_g_object_unref0 (_tmp18_);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_g_object_unref0 (found_modules);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 2083 "config-schema.c"
												goto __catch1_desktop_agnostic_vfs_glob_error;
											}
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											_g_free0 (module_glob);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											(search_paths == NULL) ? NULL : (search_paths = (_g_slist_free__g_free0_ (search_paths), NULL));
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											(type_modules == NULL) ? NULL : (type_modules = (_g_list_free__g_free0_ (type_modules), NULL));
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
											g_clear_error (&_inner_error0_);
#line 2098 "config-schema.c"
										}
									} else {
										const gchar* _tmp43_;
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
										_tmp43_ = module;
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
										g_warning ("config-schema.vala:125: Could not load the config type module: %s", _tmp43_);
#line 2106 "config-schema.c"
									}
								}
							}
						}
					}
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_g_object_unref0 (_tmp18_);
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_g_object_unref0 (found_modules);
#line 2116 "config-schema.c"
				}
				goto __finally1;
				__catch1_desktop_agnostic_vfs_glob_error:
				{
					GError* err = NULL;
					GError* _tmp44_;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					err = _inner_error0_;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_inner_error0_ = NULL;
#line 132 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_tmp44_ = err;
#line 132 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					if (!g_error_matches (_tmp44_, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH)) {
#line 2131 "config-schema.c"
						GError* _tmp45_;
						const gchar* _tmp46_;
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp45_ = err;
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						_tmp46_ = _tmp45_->message;
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
						g_warning ("config-schema.vala:134: Glob-related error: %s", _tmp46_);
#line 2140 "config-schema.c"
					}
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_g_error_free0 (err);
#line 2144 "config-schema.c"
				}
				__finally1:
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					_g_free0 (module_glob);
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					(search_paths == NULL) ? NULL : (search_paths = (_g_slist_free__g_free0_ (search_paths), NULL));
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					(type_modules == NULL) ? NULL : (type_modules = (_g_list_free__g_free0_ (type_modules), NULL));
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
					g_clear_error (&_inner_error0_);
#line 2161 "config-schema.c"
				}
#line 93 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				_g_free0 (module_glob);
#line 2165 "config-schema.c"
			}
		}
	}
#line 139 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_value_init (&_tmp47_, G_TYPE_BOOLEAN);
#line 139 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	val = _tmp47_;
#line 140 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_value_set_boolean (&val, TRUE);
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp48_ = desktop_agnostic_config_schema_common_metadata_keys;
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp49_ = g_strdup ("single_instance");
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp50_ = val;
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp51_ = _tmp50_;
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_tmp52_ = __g_value_dup0 (&_tmp51_);
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_hash_table_insert (_tmp48_, _tmp49_, _tmp52_);
#line 2187 "config-schema.c"
	{
#line 145 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		desktop_agnostic_config_get_type (&_inner_error0_);
#line 145 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2193 "config-schema.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* err = NULL;
		GError* _tmp53_;
		const gchar* _tmp54_;
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		err = _inner_error0_;
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_inner_error0_ = NULL;
#line 149 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp53_ = err;
#line 149 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_tmp54_ = _tmp53_->message;
#line 149 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_critical ("config-schema.vala:149: Config error: %s", _tmp54_);
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		_g_error_free0 (err);
#line 2215 "config-schema.c"
	}
	__finally3:
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		(search_paths == NULL) ? NULL : (search_paths = (_g_slist_free__g_free0_ (search_paths), NULL));
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		(type_modules == NULL) ? NULL : (type_modules = (_g_list_free__g_free0_ (type_modules), NULL));
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_clear_error (&_inner_error0_);
#line 2232 "config-schema.c"
	}
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(search_paths == NULL) ? NULL : (search_paths = (_g_slist_free__g_free0_ (search_paths), NULL));
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(type_modules == NULL) ? NULL : (type_modules = (_g_list_free__g_free0_ (type_modules), NULL));
#line 2242 "config-schema.c"
}

static void
desktop_agnostic_config_schema_instance_init (DesktopAgnosticConfigSchema * self,
                                              gpointer klass)
{
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	self->priv = desktop_agnostic_config_schema_get_instance_private (self);
#line 2251 "config-schema.c"
}

static void
desktop_agnostic_config_schema_finalize (GObject * obj)
{
	DesktopAgnosticConfigSchema * self;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchema);
#line 153 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_free0 (self->priv->_filename);
#line 180 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_free0 (self->priv->_app_name);
#line 182 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_g_hash_table_unref0 (self->priv->keys);
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	(self->priv->valid_metadata_keys == NULL) ? NULL : (self->priv->valid_metadata_keys = (_g_list_free__g_free0_ (self->priv->valid_metadata_keys), NULL));
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	G_OBJECT_CLASS (desktop_agnostic_config_schema_parent_class)->finalize (obj);
#line 2270 "config-schema.c"
}

/**
   * A representation of a configuration schema, comprised of one or more
   * configuration options.
   */
static GType
desktop_agnostic_config_schema_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticConfigSchemaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_config_schema_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticConfigSchema), 0, (GInstanceInitFunc) desktop_agnostic_config_schema_instance_init, NULL };
	GType desktop_agnostic_config_schema_type_id;
	desktop_agnostic_config_schema_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticConfigSchema", &g_define_type_info, 0);
	DesktopAgnosticConfigSchema_private_offset = g_type_add_instance_private (desktop_agnostic_config_schema_type_id, sizeof (DesktopAgnosticConfigSchemaPrivate));
	return desktop_agnostic_config_schema_type_id;
}

GType
desktop_agnostic_config_schema_get_type (void)
{
	static volatile gsize desktop_agnostic_config_schema_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_config_schema_type_id__once)) {
		GType desktop_agnostic_config_schema_type_id;
		desktop_agnostic_config_schema_type_id = desktop_agnostic_config_schema_get_type_once ();
		g_once_init_leave (&desktop_agnostic_config_schema_type_id__once, desktop_agnostic_config_schema_type_id);
	}
	return desktop_agnostic_config_schema_type_id__once;
}

static void
_vala_desktop_agnostic_config_schema_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	DesktopAgnosticConfigSchema * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchema);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	switch (property_id) {
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME_PROPERTY:
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		g_value_set_string (value, desktop_agnostic_config_schema_get_app_name (self));
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		break;
#line 2315 "config-schema.c"
		default:
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		break;
#line 2321 "config-schema.c"
	}
}

static void
_vala_desktop_agnostic_config_schema_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	DesktopAgnosticConfigSchema * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchema);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	switch (property_id) {
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME_PROPERTY:
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		desktop_agnostic_config_schema_set_filename (self, g_value_get_string (value));
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		break;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME_PROPERTY:
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		desktop_agnostic_config_schema_set_app_name (self, g_value_get_string (value));
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		break;
#line 2347 "config-schema.c"
		default:
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		break;
#line 2353 "config-schema.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2364 "config-schema.c"
		gssize i;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2372 "config-schema.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config-schema.vala"
	g_free (array);
#line 2387 "config-schema.c"
}

