/* config.c generated by valac 0.56.17, the Vala compiler
 * generated from config.vala, do not modify */

/*
 * Interface for the configuration implementations.
 *
 * Copyright (C) 2008, 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "desktop-agnostic-cfg.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <libdesktop-agnostic/desktop-agnostic.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_0_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_NAME_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_SCHEMA_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_INSTANCE_ID_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_config_backend_properties[DESKTOP_AGNOSTIC_CONFIG_BACKEND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

/**
   * Errors which occur when setting/retrieving configuration options.
   */
struct _DesktopAgnosticConfigBackendPrivate {
	DesktopAgnosticConfigSchema* _schema;
	gchar* _instance_id;
};

static gint DesktopAgnosticConfigBackend_private_offset;
static gpointer desktop_agnostic_config_backend_parent_class = NULL;
static GHashTable* desktop_agnostic_config_backend__backend_metadata_keys;
static GHashTable* desktop_agnostic_config_backend__backend_metadata_keys = NULL;
VALA_EXTERN GType* desktop_agnostic_config_module_type;
GType* desktop_agnostic_config_module_type = NULL;

static void _g_free0_ (gpointer var);
static void _vala_GValue_free (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static void desktop_agnostic_config_backend_real_reset (DesktopAgnosticConfigBackend* self,
                                                 GError** error);
static void desktop_agnostic_config_backend_real_remove (DesktopAgnosticConfigBackend* self,
                                                  GError** error);
static void desktop_agnostic_config_backend_real_notify_add (DesktopAgnosticConfigBackend* self,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      DesktopAgnosticConfigNotifyFunc callback,
                                                      gpointer callback_target,
                                                      GError** error);
static void desktop_agnostic_config_backend_real_notify (DesktopAgnosticConfigBackend* self,
                                                  const gchar* group,
                                                  const gchar* key,
                                                  GError** error);
static void desktop_agnostic_config_backend_real_notify_remove (DesktopAgnosticConfigBackend* self,
                                                         const gchar* group,
                                                         const gchar* key,
                                                         DesktopAgnosticConfigNotifyFunc callback,
                                                         gpointer callback_target,
                                                         GError** error);
static void desktop_agnostic_config_backend_real_get_value (DesktopAgnosticConfigBackend* self,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     GValue* result,
                                                     GError** error);
static void desktop_agnostic_config_backend_real_set_value (DesktopAgnosticConfigBackend* self,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     GValue* value,
                                                     GError** error);
static gboolean desktop_agnostic_config_backend_real_get_bool (DesktopAgnosticConfigBackend* self,
                                                        const gchar* group,
                                                        const gchar* key,
                                                        GError** error);
static void desktop_agnostic_config_backend_real_set_bool (DesktopAgnosticConfigBackend* self,
                                                    const gchar* group,
                                                    const gchar* key,
                                                    gboolean value,
                                                    GError** error);
static gfloat desktop_agnostic_config_backend_real_get_float (DesktopAgnosticConfigBackend* self,
                                                       const gchar* group,
                                                       const gchar* key,
                                                       GError** error);
static void desktop_agnostic_config_backend_real_set_float (DesktopAgnosticConfigBackend* self,
                                                     const gchar* group,
                                                     const gchar* key,
                                                     gfloat value,
                                                     GError** error);
static gint desktop_agnostic_config_backend_real_get_int (DesktopAgnosticConfigBackend* self,
                                                   const gchar* group,
                                                   const gchar* key,
                                                   GError** error);
static void desktop_agnostic_config_backend_real_set_int (DesktopAgnosticConfigBackend* self,
                                                   const gchar* group,
                                                   const gchar* key,
                                                   gint value,
                                                   GError** error);
static gchar* desktop_agnostic_config_backend_real_get_string (DesktopAgnosticConfigBackend* self,
                                                        const gchar* group,
                                                        const gchar* key,
                                                        GError** error);
static void desktop_agnostic_config_backend_real_set_string (DesktopAgnosticConfigBackend* self,
                                                      const gchar* group,
                                                      const gchar* key,
                                                      const gchar* value,
                                                      GError** error);
static GValueArray* desktop_agnostic_config_backend_real_get_list (DesktopAgnosticConfigBackend* self,
                                                            const gchar* group,
                                                            const gchar* key,
                                                            GError** error);
static void desktop_agnostic_config_backend_real_set_list (DesktopAgnosticConfigBackend* self,
                                                    const gchar* group,
                                                    const gchar* key,
                                                    GValueArray* value,
                                                    GError** error);
static void desktop_agnostic_config_backend_finalize (GObject * obj);
static GType desktop_agnostic_config_backend_get_type_once (void);
static void _vala_desktop_agnostic_config_backend_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_desktop_agnostic_config_backend_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);
static GType* _g_type_dup (GType* self);

GQuark
desktop_agnostic_config_error_quark (void)
{
	return g_quark_from_static_string ("desktop-agnostic-config-error-quark");
}

static GType
desktop_agnostic_config_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_CONFIG_ERROR_NO_SCHEMA, "DESKTOP_AGNOSTIC_CONFIG_ERROR_NO_SCHEMA", "no-schema"}, {DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE", "invalid-type"}, {DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND", "key-not-found"}, {DESKTOP_AGNOSTIC_CONFIG_ERROR_METADATA_NOT_FOUND, "DESKTOP_AGNOSTIC_CONFIG_ERROR_METADATA_NOT_FOUND", "metadata-not-found"}, {DESKTOP_AGNOSTIC_CONFIG_ERROR_NOTIFY, "DESKTOP_AGNOSTIC_CONFIG_ERROR_NOTIFY", "notify"}, {DESKTOP_AGNOSTIC_CONFIG_ERROR_DUPLICATE_BINDING, "DESKTOP_AGNOSTIC_CONFIG_ERROR_DUPLICATE_BINDING", "duplicate-binding"}, {0, NULL, NULL}};
	GType desktop_agnostic_config_error_type_id;
	desktop_agnostic_config_error_type_id = g_enum_register_static ("DesktopAgnosticConfigError", values);
	return desktop_agnostic_config_error_type_id;
}

GType
desktop_agnostic_config_error_get_type (void)
{
	static volatile gsize desktop_agnostic_config_error_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_config_error_type_id__once)) {
		GType desktop_agnostic_config_error_type_id;
		desktop_agnostic_config_error_type_id = desktop_agnostic_config_error_get_type_once ();
		g_once_init_leave (&desktop_agnostic_config_error_type_id__once, desktop_agnostic_config_error_type_id);
	}
	return desktop_agnostic_config_error_type_id__once;
}

static inline gpointer
desktop_agnostic_config_backend_get_instance_private (DesktopAgnosticConfigBackend* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticConfigBackend_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	var = (g_free (var), NULL);
#line 200 "config.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 208 "config.c"
}

static void
__vala_GValue_free0_ (gpointer var)
{
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 216 "config.c"
}

GHashTable*
desktop_agnostic_config_backend_get_backend_metadata_keys (void)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp4_;
	GHashTable* result;
#line 62 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp0_ = desktop_agnostic_config_backend__backend_metadata_keys;
#line 62 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_tmp0_ == NULL) {
#line 229 "config.c"
		GHashFunc _tmp1_;
		GEqualFunc _tmp2_;
		GHashTable* _tmp3_;
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp1_ = g_str_hash;
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp2_ = g_str_equal;
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, __vala_GValue_free0_);
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_g_hash_table_unref0 (desktop_agnostic_config_backend__backend_metadata_keys);
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		desktop_agnostic_config_backend__backend_metadata_keys = _tmp3_;
#line 243 "config.c"
	}
#line 67 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp4_ = desktop_agnostic_config_backend__backend_metadata_keys;
#line 67 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	result = _tmp4_;
#line 67 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return result;
#line 251 "config.c"
}

/**
     * Resets the configuration to the default values.
     * @throws Error if something wrong happened during the reset
     */
static void
desktop_agnostic_config_backend_real_reset (DesktopAgnosticConfigBackend* self,
                                            GError** error)
{
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_reset'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 266 "config.c"
}

void
desktop_agnostic_config_backend_reset (DesktopAgnosticConfigBackend* self,
                                       GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->reset) {
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->reset (self, error);
#line 282 "config.c"
	}
}

/**
     * Removes all of the configuration.
     * @throws Error if the config removal could not be completed.
     */
static void
desktop_agnostic_config_backend_real_remove (DesktopAgnosticConfigBackend* self,
                                             GError** error)
{
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_remove'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 298 "config.c"
}

void
desktop_agnostic_config_backend_remove (DesktopAgnosticConfigBackend* self,
                                        GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->remove) {
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->remove (self, error);
#line 314 "config.c"
	}
}

/**
     * Adds a notification callback to the specified key.
     * @param group the group the key is associated with
     * @param key the config key to associate the callback with
     */
static void
desktop_agnostic_config_backend_real_notify_add (DesktopAgnosticConfigBackend* self,
                                                 const gchar* group,
                                                 const gchar* key,
                                                 DesktopAgnosticConfigNotifyFunc callback,
                                                 gpointer callback_target,
                                                 GError** error)
{
#line 109 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_notify_add'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 109 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 335 "config.c"
}

void
desktop_agnostic_config_backend_notify_add (DesktopAgnosticConfigBackend* self,
                                            const gchar* group,
                                            const gchar* key,
                                            DesktopAgnosticConfigNotifyFunc callback,
                                            gpointer callback_target,
                                            GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 109 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 109 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 109 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->notify_add) {
#line 109 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->notify_add (self, group, key, callback, callback_target, error);
#line 355 "config.c"
	}
}

/**
     * Manually executes all of the notification callbacks associated with the
     * specified key.
     * @param group the group the key is associated with
     * @param key the config key that is associated with the callback(s)
     */
static void
desktop_agnostic_config_backend_real_notify (DesktopAgnosticConfigBackend* self,
                                             const gchar* group,
                                             const gchar* key,
                                             GError** error)
{
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_notify'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 375 "config.c"
}

void
desktop_agnostic_config_backend_notify (DesktopAgnosticConfigBackend* self,
                                        const gchar* group,
                                        const gchar* key,
                                        GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->notify) {
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->notify (self, group, key, error);
#line 393 "config.c"
	}
}

/**
     * Removes the specified notification callback for the specified key.
     * @param group the group the key is associated with
     * @param key the config key that is associated with the callback
     * @param callback the callback to remove
     * @throws Error if the callback is not associated with the key, among
     * other things
     */
static void
desktop_agnostic_config_backend_real_notify_remove (DesktopAgnosticConfigBackend* self,
                                                    const gchar* group,
                                                    const gchar* key,
                                                    DesktopAgnosticConfigNotifyFunc callback,
                                                    gpointer callback_target,
                                                    GError** error)
{
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_notify_remove'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 417 "config.c"
}

void
desktop_agnostic_config_backend_notify_remove (DesktopAgnosticConfigBackend* self,
                                               const gchar* group,
                                               const gchar* key,
                                               DesktopAgnosticConfigNotifyFunc callback,
                                               gpointer callback_target,
                                               GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->notify_remove) {
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->notify_remove (self, group, key, callback, callback_target, error);
#line 437 "config.c"
	}
}

static void
desktop_agnostic_config_backend_real_get_value (DesktopAgnosticConfigBackend* self,
                                                const gchar* group,
                                                const gchar* key,
                                                GValue* result,
                                                GError** error)
{
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_get_value'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 452 "config.c"
}

void
desktop_agnostic_config_backend_get_value (DesktopAgnosticConfigBackend* self,
                                           const gchar* group,
                                           const gchar* key,
                                           GValue* result,
                                           GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->get_value) {
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->get_value (self, group, key, result, error);
#line 471 "config.c"
	}
}

/**
     * Sets the configuration option to the specified value.
     * @param group the group the key is associated with
     * @param key the config key that is associated with the value
     * @param value the new value of the configuration option
     * @throws Error if the group/key does not exist, the value type is not
     * supported, or something bad happened while trying to set the value
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return self ? g_object_ref (self) : NULL;
#line 488 "config.c"
}

static void
desktop_agnostic_config_backend_real_set_value (DesktopAgnosticConfigBackend* self,
                                                const gchar* group,
                                                const gchar* key,
                                                GValue* value,
                                                GError** error)
{
	DesktopAgnosticConfigSchemaOption* option = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchemaOption* _tmp1_;
	DesktopAgnosticConfigSchemaOption* _tmp2_;
	GType option_type = 0UL;
	DesktopAgnosticConfigSchemaOption* _tmp3_;
	DesktopAgnosticConfigSchemaOption* _tmp5_;
	GType _tmp6_;
	GType _tmp7_;
	GError* _inner_error0_ = NULL;
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (group != NULL);
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (key != NULL);
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (value != NULL);
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp0_ = self->priv->_schema;
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp1_ = desktop_agnostic_config_schema_get_option (_tmp0_, group, key);
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	option = _tmp2_;
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp3_ = option;
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_tmp3_ == NULL) {
#line 526 "config.c"
		GError* _tmp4_;
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp4_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "Could not find group and/or key in schema.");
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_inner_error0_ = _tmp4_;
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		g_propagate_error (error, _inner_error0_);
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_g_object_unref0 (option);
#line 143 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return;
#line 538 "config.c"
	}
#line 146 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp5_ = option;
#line 146 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp6_ = desktop_agnostic_config_schema_option_get_option_type (_tmp5_);
#line 146 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp7_ = _tmp6_;
#line 146 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	option_type = _tmp7_;
#line 148 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (option_type == G_TYPE_BOOLEAN) {
#line 550 "config.c"
		GValue _tmp8_;
#line 150 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp8_ = *value;
#line 150 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		desktop_agnostic_config_backend_set_bool (self, group, key, g_value_get_boolean (&_tmp8_), &_inner_error0_);
#line 150 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			g_propagate_error (error, _inner_error0_);
#line 150 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_g_object_unref0 (option);
#line 150 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			return;
#line 564 "config.c"
		}
	} else {
#line 152 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		if (option_type == G_TYPE_FLOAT) {
#line 569 "config.c"
			gfloat _tmp9_ = 0.0F;
			GValue _tmp10_;
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_tmp10_ = *value;
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_tmp9_ = desktop_agnostic_config_backend_get_float_from_value (&_tmp10_, &_inner_error0_);
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				g_propagate_error (error, _inner_error0_);
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				_g_object_unref0 (option);
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				return;
#line 584 "config.c"
			}
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			desktop_agnostic_config_backend_set_float (self, group, key, _tmp9_, &_inner_error0_);
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				g_propagate_error (error, _inner_error0_);
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				_g_object_unref0 (option);
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				return;
#line 596 "config.c"
			}
		} else {
#line 156 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			if (option_type == G_TYPE_INT) {
#line 601 "config.c"
				gint _tmp11_ = 0;
				GValue _tmp12_;
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				_tmp12_ = *value;
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				_tmp11_ = desktop_agnostic_config_backend_get_int_from_value (&_tmp12_, &_inner_error0_);
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					g_propagate_error (error, _inner_error0_);
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					_g_object_unref0 (option);
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					return;
#line 616 "config.c"
				}
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				desktop_agnostic_config_backend_set_int (self, group, key, _tmp11_, &_inner_error0_);
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					g_propagate_error (error, _inner_error0_);
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					_g_object_unref0 (option);
#line 158 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					return;
#line 628 "config.c"
				}
			} else {
#line 160 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				if (option_type == G_TYPE_STRING) {
#line 633 "config.c"
					GValue _tmp13_;
#line 162 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					_tmp13_ = *value;
#line 162 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					desktop_agnostic_config_backend_set_string (self, group, key, g_value_get_string (&_tmp13_), &_inner_error0_);
#line 162 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 162 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						g_propagate_error (error, _inner_error0_);
#line 162 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						_g_object_unref0 (option);
#line 162 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						return;
#line 647 "config.c"
					}
				} else {
#line 164 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
					if (option_type == G_TYPE_VALUE_ARRAY) {
#line 652 "config.c"
						GValue _tmp14_;
#line 166 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						_tmp14_ = *value;
#line 166 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						desktop_agnostic_config_backend_set_list (self, group, key, g_value_get_boxed (&_tmp14_), &_inner_error0_);
#line 166 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							g_propagate_error (error, _inner_error0_);
#line 166 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_g_object_unref0 (option);
#line 166 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							return;
#line 666 "config.c"
						}
					} else {
						DesktopAgnosticConfigSchemaType* st = NULL;
						DesktopAgnosticConfigSchemaType* _tmp15_;
						DesktopAgnosticConfigSchemaType* _tmp16_;
						DesktopAgnosticConfigSchemaType* _tmp17_;
#line 170 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						_tmp15_ = desktop_agnostic_config_schema_find_type (option_type);
#line 170 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						_tmp16_ = _g_object_ref0 (_tmp15_);
#line 170 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						st = _tmp16_;
#line 171 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						_tmp17_ = st;
#line 171 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						if (_tmp17_ == NULL) {
#line 683 "config.c"
							GError* _tmp18_;
#line 173 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_tmp18_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "Invalid config value type.");
#line 173 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_inner_error0_ = _tmp18_;
#line 173 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							g_propagate_error (error, _inner_error0_);
#line 173 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_g_object_unref0 (st);
#line 173 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_g_object_unref0 (option);
#line 173 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							return;
#line 697 "config.c"
						} else {
							gchar* _tmp19_ = NULL;
							DesktopAgnosticConfigSchemaType* _tmp20_;
							GValue _tmp21_;
							gchar* _tmp22_;
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_tmp20_ = st;
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_tmp21_ = *value;
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_tmp22_ = desktop_agnostic_config_schema_type_serialize (_tmp20_, &_tmp21_, &_inner_error0_);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_tmp19_ = _tmp22_;
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								g_propagate_error (error, _inner_error0_);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								_g_object_unref0 (st);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								_g_object_unref0 (option);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								return;
#line 721 "config.c"
							}
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							desktop_agnostic_config_backend_set_string (self, group, key, _tmp19_, &_inner_error0_);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								g_propagate_error (error, _inner_error0_);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								_g_free0 (_tmp19_);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								_g_object_unref0 (st);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								_g_object_unref0 (option);
#line 177 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
								return;
#line 737 "config.c"
							}
#line 171 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
							_g_free0 (_tmp19_);
#line 741 "config.c"
						}
#line 164 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
						_g_object_unref0 (st);
#line 745 "config.c"
					}
				}
			}
		}
	}
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_g_object_unref0 (option);
#line 753 "config.c"
}

void
desktop_agnostic_config_backend_set_value (DesktopAgnosticConfigBackend* self,
                                           const gchar* group,
                                           const gchar* key,
                                           GValue* value,
                                           GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->set_value) {
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->set_value (self, group, key, value, error);
#line 772 "config.c"
	}
}

static gboolean
desktop_agnostic_config_backend_real_get_bool (DesktopAgnosticConfigBackend* self,
                                               const gchar* group,
                                               const gchar* key,
                                               GError** error)
{
	gboolean _tmp0_ = FALSE;
#line 181 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_get_bool'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 181 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return _tmp0_;
#line 787 "config.c"
}

gboolean
desktop_agnostic_config_backend_get_bool (DesktopAgnosticConfigBackend* self,
                                          const gchar* group,
                                          const gchar* key,
                                          GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 181 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 181 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 181 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->get_bool) {
#line 181 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return _klass_->get_bool (self, group, key, error);
#line 805 "config.c"
	}
#line 181 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return FALSE;
#line 809 "config.c"
}

static void
desktop_agnostic_config_backend_real_set_bool (DesktopAgnosticConfigBackend* self,
                                               const gchar* group,
                                               const gchar* key,
                                               gboolean value,
                                               GError** error)
{
#line 182 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_set_bool'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 182 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 823 "config.c"
}

void
desktop_agnostic_config_backend_set_bool (DesktopAgnosticConfigBackend* self,
                                          const gchar* group,
                                          const gchar* key,
                                          gboolean value,
                                          GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 182 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 182 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 182 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->set_bool) {
#line 182 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->set_bool (self, group, key, value, error);
#line 842 "config.c"
	}
}

static gfloat
desktop_agnostic_config_backend_real_get_float (DesktopAgnosticConfigBackend* self,
                                                const gchar* group,
                                                const gchar* key,
                                                GError** error)
{
	gfloat _tmp0_ = 0.0F;
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_get_float'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return _tmp0_;
#line 857 "config.c"
}

gfloat
desktop_agnostic_config_backend_get_float (DesktopAgnosticConfigBackend* self,
                                           const gchar* group,
                                           const gchar* key,
                                           GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->get_float) {
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return _klass_->get_float (self, group, key, error);
#line 875 "config.c"
	}
#line 183 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return -1.0F;
#line 879 "config.c"
}

static void
desktop_agnostic_config_backend_real_set_float (DesktopAgnosticConfigBackend* self,
                                                const gchar* group,
                                                const gchar* key,
                                                gfloat value,
                                                GError** error)
{
#line 184 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_set_float'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 184 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 893 "config.c"
}

void
desktop_agnostic_config_backend_set_float (DesktopAgnosticConfigBackend* self,
                                           const gchar* group,
                                           const gchar* key,
                                           gfloat value,
                                           GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 184 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 184 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 184 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->set_float) {
#line 184 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->set_float (self, group, key, value, error);
#line 912 "config.c"
	}
}

static gint
desktop_agnostic_config_backend_real_get_int (DesktopAgnosticConfigBackend* self,
                                              const gchar* group,
                                              const gchar* key,
                                              GError** error)
{
	gint _tmp0_ = 0;
#line 185 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_get_int'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 185 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return _tmp0_;
#line 927 "config.c"
}

gint
desktop_agnostic_config_backend_get_int (DesktopAgnosticConfigBackend* self,
                                         const gchar* group,
                                         const gchar* key,
                                         GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 185 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 185 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 185 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->get_int) {
#line 185 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return _klass_->get_int (self, group, key, error);
#line 945 "config.c"
	}
#line 185 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return -1;
#line 949 "config.c"
}

static void
desktop_agnostic_config_backend_real_set_int (DesktopAgnosticConfigBackend* self,
                                              const gchar* group,
                                              const gchar* key,
                                              gint value,
                                              GError** error)
{
#line 186 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_set_int'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 186 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 963 "config.c"
}

void
desktop_agnostic_config_backend_set_int (DesktopAgnosticConfigBackend* self,
                                         const gchar* group,
                                         const gchar* key,
                                         gint value,
                                         GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 186 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 186 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 186 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->set_int) {
#line 186 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->set_int (self, group, key, value, error);
#line 982 "config.c"
	}
}

static gchar*
desktop_agnostic_config_backend_real_get_string (DesktopAgnosticConfigBackend* self,
                                                 const gchar* group,
                                                 const gchar* key,
                                                 GError** error)
{
#line 187 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_get_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 187 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return NULL;
#line 996 "config.c"
}

gchar*
desktop_agnostic_config_backend_get_string (DesktopAgnosticConfigBackend* self,
                                            const gchar* group,
                                            const gchar* key,
                                            GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 187 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 187 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->get_string) {
#line 187 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return _klass_->get_string (self, group, key, error);
#line 1014 "config.c"
	}
#line 187 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return NULL;
#line 1018 "config.c"
}

static void
desktop_agnostic_config_backend_real_set_string (DesktopAgnosticConfigBackend* self,
                                                 const gchar* group,
                                                 const gchar* key,
                                                 const gchar* value,
                                                 GError** error)
{
#line 188 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_set_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 188 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 1032 "config.c"
}

void
desktop_agnostic_config_backend_set_string (DesktopAgnosticConfigBackend* self,
                                            const gchar* group,
                                            const gchar* key,
                                            const gchar* value,
                                            GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 188 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 188 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 188 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->set_string) {
#line 188 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->set_string (self, group, key, value, error);
#line 1051 "config.c"
	}
}

static GValueArray*
desktop_agnostic_config_backend_real_get_list (DesktopAgnosticConfigBackend* self,
                                               const gchar* group,
                                               const gchar* key,
                                               GError** error)
{
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_get_list'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return NULL;
#line 1065 "config.c"
}

GValueArray*
desktop_agnostic_config_backend_get_list (DesktopAgnosticConfigBackend* self,
                                          const gchar* group,
                                          const gchar* key,
                                          GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->get_list) {
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return _klass_->get_list (self, group, key, error);
#line 1083 "config.c"
	}
#line 189 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return NULL;
#line 1087 "config.c"
}

static void
desktop_agnostic_config_backend_real_set_list (DesktopAgnosticConfigBackend* self,
                                               const gchar* group,
                                               const gchar* key,
                                               GValueArray* value,
                                               GError** error)
{
#line 190 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_critical ("Type `%s' does not implement abstract method `desktop_agnostic_config_backend_set_list'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 190 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return;
#line 1101 "config.c"
}

void
desktop_agnostic_config_backend_set_list (DesktopAgnosticConfigBackend* self,
                                          const gchar* group,
                                          const gchar* key,
                                          GValueArray* value,
                                          GError** error)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 190 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 190 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 190 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->set_list) {
#line 190 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_klass_->set_list (self, group, key, value, error);
#line 1120 "config.c"
	}
}

gfloat
desktop_agnostic_config_backend_get_float_from_value (GValue* value,
                                                      GError** error)
{
	GError* _inner_error0_ = NULL;
	gfloat result;
#line 192 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (value != NULL, 0.0F);
#line 195 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (G_VALUE_HOLDS (value, G_TYPE_FLOAT)) {
#line 1134 "config.c"
		GValue _tmp0_;
#line 197 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp0_ = *value;
#line 197 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		result = g_value_get_float (&_tmp0_);
#line 197 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return result;
#line 1142 "config.c"
	} else {
#line 199 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		if (g_value_type_transformable (G_VALUE_TYPE (value), G_TYPE_FLOAT)) {
#line 1146 "config.c"
			GValue converted = {0};
			GValue _tmp1_ = {0};
			GValue _tmp2_;
#line 201 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			g_value_init (&_tmp1_, G_TYPE_FLOAT);
#line 201 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			converted = _tmp1_;
#line 202 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			g_value_transform (value, &converted);
#line 203 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_tmp2_ = converted;
#line 203 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			result = g_value_get_float (&_tmp2_);
#line 203 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			G_IS_VALUE (&converted) ? (g_value_unset (&converted), NULL) : NULL;
#line 203 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			return result;
#line 1164 "config.c"
		} else {
			const gchar* _tmp3_;
			GError* _tmp4_;
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_tmp3_ = g_type_name (G_VALUE_TYPE (value));
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_tmp4_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "Value given cannot be converted to a float: %s.", _tmp3_);
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_inner_error0_ = _tmp4_;
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 1176 "config.c"
				gfloat _tmp5_ = -1.0F;
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				g_propagate_error (error, _inner_error0_);
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				return _tmp5_;
#line 1182 "config.c"
			} else {
				gfloat _tmp6_ = -1.0F;
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				g_clear_error (&_inner_error0_);
#line 207 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				return _tmp6_;
#line 1191 "config.c"
			}
		}
	}
}

gint
desktop_agnostic_config_backend_get_int_from_value (GValue* value,
                                                    GError** error)
{
	GError* _inner_error0_ = NULL;
	gint result;
#line 212 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 215 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (G_VALUE_HOLDS (value, G_TYPE_INT)) {
#line 1207 "config.c"
		GValue _tmp0_;
#line 217 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp0_ = *value;
#line 217 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		result = g_value_get_int (&_tmp0_);
#line 217 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return result;
#line 1215 "config.c"
	} else {
#line 219 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		if (g_value_type_transformable (G_VALUE_TYPE (value), G_TYPE_INT)) {
#line 1219 "config.c"
			GValue converted = {0};
			GValue _tmp1_ = {0};
			GValue _tmp2_;
#line 221 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			g_value_init (&_tmp1_, G_TYPE_INT);
#line 221 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			converted = _tmp1_;
#line 222 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			g_value_transform (value, &converted);
#line 223 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_tmp2_ = converted;
#line 223 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			result = g_value_get_int (&_tmp2_);
#line 223 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			G_IS_VALUE (&converted) ? (g_value_unset (&converted), NULL) : NULL;
#line 223 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			return result;
#line 1237 "config.c"
		} else {
			const gchar* _tmp3_;
			GError* _tmp4_;
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_tmp3_ = g_type_name (G_VALUE_TYPE (value));
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_tmp4_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "Value given cannot be converted to an integer: %s.", _tmp3_);
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			_inner_error0_ = _tmp4_;
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			if (_inner_error0_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
#line 1249 "config.c"
				gint _tmp5_ = -1;
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				g_propagate_error (error, _inner_error0_);
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				return _tmp5_;
#line 1255 "config.c"
			} else {
				gint _tmp6_ = -1;
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				g_clear_error (&_inner_error0_);
#line 227 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
				return _tmp6_;
#line 1264 "config.c"
			}
		}
	}
}

DesktopAgnosticConfigBackend*
desktop_agnostic_config_backend_construct (GType object_type)
{
	DesktopAgnosticConfigBackend * self = NULL;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	self = (DesktopAgnosticConfigBackend*) g_object_new (object_type, NULL);
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return self;
#line 1278 "config.c"
}

gchar*
desktop_agnostic_config_backend_get_name (DesktopAgnosticConfigBackend* self)
{
	DesktopAgnosticConfigBackendClass* _klass_;
#line 56 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_klass_ = DESKTOP_AGNOSTIC_CONFIG_BACKEND_GET_CLASS (self);
#line 56 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_klass_->get_name) {
#line 56 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return _klass_->get_name (self);
#line 1293 "config.c"
	}
#line 56 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return NULL;
#line 1297 "config.c"
}

DesktopAgnosticConfigSchema*
desktop_agnostic_config_backend_get_schema (DesktopAgnosticConfigBackend* self)
{
	DesktopAgnosticConfigSchema* result;
	DesktopAgnosticConfigSchema* _tmp0_;
#line 73 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp0_ = self->priv->_schema;
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	result = _tmp0_;
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return result;
#line 1313 "config.c"
}

static void
desktop_agnostic_config_backend_set_schema (DesktopAgnosticConfigBackend* self,
                                            DesktopAgnosticConfigSchema* value)
{
	DesktopAgnosticConfigSchema* _tmp0_;
#line 77 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 79 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 79 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_g_object_unref0 (self->priv->_schema);
#line 79 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	self->priv->_schema = _tmp0_;
#line 77 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_config_backend_properties[DESKTOP_AGNOSTIC_CONFIG_BACKEND_SCHEMA_PROPERTY]);
#line 1331 "config.c"
}

const gchar*
desktop_agnostic_config_backend_get_instance_id (DesktopAgnosticConfigBackend* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 85 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp0_ = self->priv->_instance_id;
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	result = _tmp0_;
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return result;
#line 1347 "config.c"
}

static void
desktop_agnostic_config_backend_set_instance_id (DesktopAgnosticConfigBackend* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 89 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_if_fail (self != NULL);
#line 91 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp0_ = g_strdup (value);
#line 91 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_g_free0 (self->priv->_instance_id);
#line 91 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	self->priv->_instance_id = _tmp0_;
#line 89 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_config_backend_properties[DESKTOP_AGNOSTIC_CONFIG_BACKEND_INSTANCE_ID_PROPERTY]);
#line 1365 "config.c"
}

static void
desktop_agnostic_config_backend_class_init (DesktopAgnosticConfigBackendClass * klass,
                                            gpointer klass_data)
{
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	desktop_agnostic_config_backend_parent_class = g_type_class_peek_parent (klass);
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticConfigBackend_private_offset);
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->reset = (void (*) (DesktopAgnosticConfigBackend*, GError**)) desktop_agnostic_config_backend_real_reset;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->remove = (void (*) (DesktopAgnosticConfigBackend*, GError**)) desktop_agnostic_config_backend_real_remove;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify_add = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, DesktopAgnosticConfigNotifyFunc, gpointer, GError**)) desktop_agnostic_config_backend_real_notify_add;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_backend_real_notify;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->notify_remove = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, DesktopAgnosticConfigNotifyFunc, gpointer, GError**)) desktop_agnostic_config_backend_real_notify_remove;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_value = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GValue*, GError**)) desktop_agnostic_config_backend_real_get_value;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_value = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GValue*, GError**)) desktop_agnostic_config_backend_real_set_value;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_bool = (gboolean (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_backend_real_get_bool;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_bool = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gboolean, GError**)) desktop_agnostic_config_backend_real_set_bool;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_float = (gfloat (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_backend_real_get_float;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_float = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gfloat, GError**)) desktop_agnostic_config_backend_real_set_float;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_int = (gint (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_backend_real_get_int;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_int = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, gint, GError**)) desktop_agnostic_config_backend_real_set_int;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_string = (gchar* (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_backend_real_get_string;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_string = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_backend_real_set_string;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->get_list = (GValueArray* (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GError**)) desktop_agnostic_config_backend_real_get_list;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	((DesktopAgnosticConfigBackendClass *) klass)->set_list = (void (*) (DesktopAgnosticConfigBackend*, const gchar*, const gchar*, GValueArray*, GError**)) desktop_agnostic_config_backend_real_set_list;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_config_backend_get_property;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_config_backend_set_property;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_config_backend_finalize;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_BACKEND_NAME_PROPERTY, desktop_agnostic_config_backend_properties[DESKTOP_AGNOSTIC_CONFIG_BACKEND_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_BACKEND_SCHEMA_PROPERTY, desktop_agnostic_config_backend_properties[DESKTOP_AGNOSTIC_CONFIG_BACKEND_SCHEMA_PROPERTY] = g_param_spec_object ("schema", "schema", "schema", DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_BACKEND_INSTANCE_ID_PROPERTY, desktop_agnostic_config_backend_properties[DESKTOP_AGNOSTIC_CONFIG_BACKEND_INSTANCE_ID_PROPERTY] = g_param_spec_string ("instance-id", "instance-id", "instance-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1422 "config.c"
}

static void
desktop_agnostic_config_backend_instance_init (DesktopAgnosticConfigBackend * self,
                                               gpointer klass)
{
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	self->priv = desktop_agnostic_config_backend_get_instance_private (self);
#line 70 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	self->priv->_schema = NULL;
#line 1433 "config.c"
}

static void
desktop_agnostic_config_backend_finalize (GObject * obj)
{
	DesktopAgnosticConfigBackend * self;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_BACKEND, DesktopAgnosticConfigBackend);
#line 70 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_g_object_unref0 (self->priv->_schema);
#line 82 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_g_free0 (self->priv->_instance_id);
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	G_OBJECT_CLASS (desktop_agnostic_config_backend_parent_class)->finalize (obj);
#line 1448 "config.c"
}

/**
   * The abstract base class that defines what a configuration backend should
   * look like.
   */
static GType
desktop_agnostic_config_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticConfigBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_config_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticConfigBackend), 0, (GInstanceInitFunc) desktop_agnostic_config_backend_instance_init, NULL };
	GType desktop_agnostic_config_backend_type_id;
	desktop_agnostic_config_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticConfigBackend", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	DesktopAgnosticConfigBackend_private_offset = g_type_add_instance_private (desktop_agnostic_config_backend_type_id, sizeof (DesktopAgnosticConfigBackendPrivate));
	return desktop_agnostic_config_backend_type_id;
}

GType
desktop_agnostic_config_backend_get_type (void)
{
	static volatile gsize desktop_agnostic_config_backend_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_config_backend_type_id__once)) {
		GType desktop_agnostic_config_backend_type_id;
		desktop_agnostic_config_backend_type_id = desktop_agnostic_config_backend_get_type_once ();
		g_once_init_leave (&desktop_agnostic_config_backend_type_id__once, desktop_agnostic_config_backend_type_id);
	}
	return desktop_agnostic_config_backend_type_id__once;
}

static void
_vala_desktop_agnostic_config_backend_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	DesktopAgnosticConfigBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_BACKEND, DesktopAgnosticConfigBackend);
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	switch (property_id) {
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		case DESKTOP_AGNOSTIC_CONFIG_BACKEND_SCHEMA_PROPERTY:
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		g_value_set_object (value, desktop_agnostic_config_backend_get_schema (self));
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		break;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		case DESKTOP_AGNOSTIC_CONFIG_BACKEND_INSTANCE_ID_PROPERTY:
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		g_value_set_string (value, desktop_agnostic_config_backend_get_instance_id (self));
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		break;
#line 1499 "config.c"
		default:
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		break;
#line 1505 "config.c"
	}
}

static void
_vala_desktop_agnostic_config_backend_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	DesktopAgnosticConfigBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_BACKEND, DesktopAgnosticConfigBackend);
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	switch (property_id) {
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		case DESKTOP_AGNOSTIC_CONFIG_BACKEND_SCHEMA_PROPERTY:
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		desktop_agnostic_config_backend_set_schema (self, g_value_get_object (value));
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		break;
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		case DESKTOP_AGNOSTIC_CONFIG_BACKEND_INSTANCE_ID_PROPERTY:
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		desktop_agnostic_config_backend_set_instance_id (self, g_value_get_string (value));
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		break;
#line 1531 "config.c"
		default:
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 54 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		break;
#line 1537 "config.c"
	}
}

/**
   * Retrieve the default config backend type.
   * @return Config.Backend-based type on succes, Type.INVALID on failure
   */
static GType*
_g_type_dup (GType* self)
{
	GType* dup;
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	dup = g_new0 (GType, 1);
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	memcpy (dup, self, sizeof (GType));
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return dup;
#line 1555 "config.c"
}

static gpointer
__g_type_dup0 (gpointer self)
{
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return self ? _g_type_dup (self) : NULL;
#line 1563 "config.c"
}

GType
desktop_agnostic_config_get_type (GError** error)
{
	GType* _tmp0_;
	GType* _tmp4_;
	GError* _inner_error0_ = NULL;
	GType result;
#line 242 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp0_ = desktop_agnostic_config_module_type;
#line 242 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (_tmp0_ == NULL) {
#line 1577 "config.c"
		GType _tmp1_ = 0UL;
		GType* _tmp3_;
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp1_ = desktop_agnostic_get_module_type ("cfg", "config", &_inner_error0_);
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1584 "config.c"
			GType _tmp2_ = 0UL;
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			g_propagate_error (error, _inner_error0_);
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
			return _tmp2_;
#line 1590 "config.c"
		}
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp3_ = __g_type_dup0 (&_tmp1_);
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_g_free0 (desktop_agnostic_config_module_type);
#line 244 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		desktop_agnostic_config_module_type = _tmp3_;
#line 1598 "config.c"
	}
#line 246 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	_tmp4_ = desktop_agnostic_config_module_type;
#line 246 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	result = *_tmp4_;
#line 246 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	return result;
#line 1606 "config.c"
}

/**
   * Convenience method for instantiating a configuration backend.
   * @return a Config.Backend object on success, %NULL on failure
   */
DesktopAgnosticConfigBackend*
desktop_agnostic_config_new (DesktopAgnosticConfigSchema* schema,
                             GError** error)
{
	GType type = 0UL;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticConfigBackend* result;
#line 253 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (schema != NULL, NULL);
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	type = desktop_agnostic_config_get_type (&_inner_error0_);
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		g_propagate_error (error, _inner_error0_);
#line 256 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return NULL;
#line 1630 "config.c"
	}
#line 257 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (type == G_TYPE_INVALID) {
#line 259 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		result = NULL;
#line 259 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return result;
#line 1638 "config.c"
	} else {
		GObject* _tmp0_;
		GObject* _tmp1_;
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp0_ = g_object_new (type, "schema", schema, NULL);
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_CONFIG_TYPE_BACKEND, DesktopAgnosticConfigBackend);
#line 263 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return result;
#line 1650 "config.c"
	}
}

/**
   * Convenience method for instantiating a configuration backend with an
   * instance ID.
   * @return a Config.Backend object on success, %NULL on failure
   */
DesktopAgnosticConfigBackend*
desktop_agnostic_config_new_for_instance (const gchar* instance_id,
                                          DesktopAgnosticConfigSchema* schema,
                                          GError** error)
{
	GType type = 0UL;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticConfigBackend* result;
#line 273 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (instance_id != NULL, NULL);
#line 273 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	g_return_val_if_fail (schema != NULL, NULL);
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	type = desktop_agnostic_config_get_type (&_inner_error0_);
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		g_propagate_error (error, _inner_error0_);
#line 277 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return NULL;
#line 1679 "config.c"
	}
#line 278 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
	if (type == G_TYPE_INVALID) {
#line 280 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		result = NULL;
#line 280 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return result;
#line 1687 "config.c"
	} else {
		GObject* _tmp0_;
		GObject* _tmp1_;
#line 284 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp0_ = g_object_new (type, "schema", schema, "instance_id", instance_id, NULL);
#line 284 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 284 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_CONFIG_TYPE_BACKEND, DesktopAgnosticConfigBackend);
#line 284 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/config.vala"
		return result;
#line 1699 "config.c"
	}
}

