/* vfs-bookmarks-gtk.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-bookmarks-gtk.vala, do not modify */

/*
 * Desktop Agnostic Library: VFS GTK+ Bookmarks Parser.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * Based on the code from the Awn Places applet, author Rodney Cryderman
 * <rcryderman@gmail.com>.
 */

#include "desktop-agnostic-vfs.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_BOOKMARK_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_BOOKMARK_FILE_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_BOOKMARK_ALIAS_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_BOOKMARK_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_bookmark_properties[DESKTOP_AGNOSTIC_VFS_BOOKMARK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_FILE_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_BOOKMARKS_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_gtk_bookmarks_properties[DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_CHANGED_SIGNAL,
	DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_NUM_SIGNALS
};
static guint desktop_agnostic_vfs_gtk_bookmarks_signals[DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_NUM_SIGNALS] = {0};

struct _DesktopAgnosticVFSBookmarkPrivate {
	DesktopAgnosticVFSFile* _file;
	gchar* _alias;
};

struct _DesktopAgnosticVFSGtkBookmarksPrivate {
	DesktopAgnosticVFSFile* _file;
	DesktopAgnosticVFSFileMonitor* _monitor;
	GSList* _bookmarks;
};

static gint DesktopAgnosticVFSBookmark_private_offset;
static gpointer desktop_agnostic_vfs_bookmark_parent_class = NULL;
static gint DesktopAgnosticVFSGtkBookmarks_private_offset;
static gpointer desktop_agnostic_vfs_gtk_bookmarks_parent_class = NULL;

static void desktop_agnostic_vfs_bookmark_finalize (GObject * obj);
static GType desktop_agnostic_vfs_bookmark_get_type_once (void);
static void _vala_desktop_agnostic_vfs_bookmark_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_desktop_agnostic_vfs_bookmark_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void desktop_agnostic_vfs_gtk_bookmarks_parse (DesktopAgnosticVFSGtkBookmarks* self);
static void desktop_agnostic_vfs_gtk_bookmarks_on_file_changed (DesktopAgnosticVFSGtkBookmarks* self,
                                                         DesktopAgnosticVFSFileMonitor* monitor,
                                                         DesktopAgnosticVFSFile* file,
                                                         DesktopAgnosticVFSFile* other,
                                                         DesktopAgnosticVFSFileMonitorEvent event);
static void _desktop_agnostic_vfs_gtk_bookmarks_on_file_changed_desktop_agnostic_vfs_file_monitor_changed (DesktopAgnosticVFSFileMonitor* _sender,
                                                                                                    DesktopAgnosticVFSFile* file,
                                                                                                    DesktopAgnosticVFSFile* other,
                                                                                                    DesktopAgnosticVFSFileMonitorEvent event,
                                                                                                    gpointer self);
static void desktop_agnostic_vfs_gtk_bookmarks_finalize (GObject * obj);
static GType desktop_agnostic_vfs_gtk_bookmarks_get_type_once (void);
static void _vala_desktop_agnostic_vfs_gtk_bookmarks_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_desktop_agnostic_vfs_gtk_bookmarks_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
desktop_agnostic_vfs_bookmark_get_instance_private (DesktopAgnosticVFSBookmark* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSBookmark_private_offset);
}

DesktopAgnosticVFSBookmark*
desktop_agnostic_vfs_bookmark_construct (GType object_type)
{
	DesktopAgnosticVFSBookmark * self = NULL;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	self = (DesktopAgnosticVFSBookmark*) g_object_new (object_type, NULL);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	return self;
#line 139 "vfs-bookmarks-gtk.c"
}

DesktopAgnosticVFSBookmark*
desktop_agnostic_vfs_bookmark_new (void)
{
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	return desktop_agnostic_vfs_bookmark_construct (DESKTOP_AGNOSTIC_VFS_TYPE_BOOKMARK);
#line 147 "vfs-bookmarks-gtk.c"
}

DesktopAgnosticVFSFile*
desktop_agnostic_vfs_bookmark_get_file (DesktopAgnosticVFSBookmark* self)
{
	DesktopAgnosticVFSFile* result;
	DesktopAgnosticVFSFile* _tmp0_;
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	_tmp0_ = self->priv->_file;
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	result = _tmp0_;
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	return result;
#line 163 "vfs-bookmarks-gtk.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	return self ? g_object_ref (self) : NULL;
#line 171 "vfs-bookmarks-gtk.c"
}

void
desktop_agnostic_vfs_bookmark_set_file (DesktopAgnosticVFSBookmark* self,
                                        DesktopAgnosticVFSFile* value)
{
	DesktopAgnosticVFSFile* old_value;
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_if_fail (self != NULL);
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	old_value = desktop_agnostic_vfs_bookmark_get_file (self);
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	if (old_value != value) {
#line 185 "vfs-bookmarks-gtk.c"
		DesktopAgnosticVFSFile* _tmp0_;
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_object_unref0 (self->priv->_file);
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		self->priv->_file = _tmp0_;
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_vfs_bookmark_properties[DESKTOP_AGNOSTIC_VFS_BOOKMARK_FILE_PROPERTY]);
#line 195 "vfs-bookmarks-gtk.c"
	}
}

const gchar*
desktop_agnostic_vfs_bookmark_get_alias (DesktopAgnosticVFSBookmark* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	_tmp0_ = self->priv->_alias;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	result = _tmp0_;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	return result;
#line 212 "vfs-bookmarks-gtk.c"
}

void
desktop_agnostic_vfs_bookmark_set_alias (DesktopAgnosticVFSBookmark* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_if_fail (self != NULL);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	old_value = desktop_agnostic_vfs_bookmark_get_alias (self);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 226 "vfs-bookmarks-gtk.c"
		gchar* _tmp0_;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp0_ = g_strdup (value);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_free0 (self->priv->_alias);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		self->priv->_alias = _tmp0_;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_vfs_bookmark_properties[DESKTOP_AGNOSTIC_VFS_BOOKMARK_ALIAS_PROPERTY]);
#line 236 "vfs-bookmarks-gtk.c"
	}
}

static void
desktop_agnostic_vfs_bookmark_class_init (DesktopAgnosticVFSBookmarkClass * klass,
                                          gpointer klass_data)
{
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	desktop_agnostic_vfs_bookmark_parent_class = g_type_class_peek_parent (klass);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSBookmark_private_offset);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_bookmark_get_property;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_vfs_bookmark_set_property;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_bookmark_finalize;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_BOOKMARK_FILE_PROPERTY, desktop_agnostic_vfs_bookmark_properties[DESKTOP_AGNOSTIC_VFS_BOOKMARK_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", DESKTOP_AGNOSTIC_VFS_TYPE_FILE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_BOOKMARK_ALIAS_PROPERTY, desktop_agnostic_vfs_bookmark_properties[DESKTOP_AGNOSTIC_VFS_BOOKMARK_ALIAS_PROPERTY] = g_param_spec_string ("alias", "alias", "alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 258 "vfs-bookmarks-gtk.c"
}

static void
desktop_agnostic_vfs_bookmark_instance_init (DesktopAgnosticVFSBookmark * self,
                                             gpointer klass)
{
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	self->priv = desktop_agnostic_vfs_bookmark_get_instance_private (self);
#line 267 "vfs-bookmarks-gtk.c"
}

static void
desktop_agnostic_vfs_bookmark_finalize (GObject * obj)
{
	DesktopAgnosticVFSBookmark * self;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_BOOKMARK, DesktopAgnosticVFSBookmark);
#line 35 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	_g_object_unref0 (self->priv->_file);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	_g_free0 (self->priv->_alias);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_bookmark_parent_class)->finalize (obj);
#line 282 "vfs-bookmarks-gtk.c"
}

/**
   * A representation of a simple bookmark.
   */
static GType
desktop_agnostic_vfs_bookmark_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSBookmarkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_bookmark_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSBookmark), 0, (GInstanceInitFunc) desktop_agnostic_vfs_bookmark_instance_init, NULL };
	GType desktop_agnostic_vfs_bookmark_type_id;
	desktop_agnostic_vfs_bookmark_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSBookmark", &g_define_type_info, 0);
	DesktopAgnosticVFSBookmark_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_bookmark_type_id, sizeof (DesktopAgnosticVFSBookmarkPrivate));
	return desktop_agnostic_vfs_bookmark_type_id;
}

GType
desktop_agnostic_vfs_bookmark_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_bookmark_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_bookmark_type_id__once)) {
		GType desktop_agnostic_vfs_bookmark_type_id;
		desktop_agnostic_vfs_bookmark_type_id = desktop_agnostic_vfs_bookmark_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_bookmark_type_id__once, desktop_agnostic_vfs_bookmark_type_id);
	}
	return desktop_agnostic_vfs_bookmark_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_bookmark_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	DesktopAgnosticVFSBookmark * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_BOOKMARK, DesktopAgnosticVFSBookmark);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	switch (property_id) {
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_BOOKMARK_FILE_PROPERTY:
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_value_set_object (value, desktop_agnostic_vfs_bookmark_get_file (self));
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_BOOKMARK_ALIAS_PROPERTY:
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_value_set_string (value, desktop_agnostic_vfs_bookmark_get_alias (self));
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 332 "vfs-bookmarks-gtk.c"
		default:
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 338 "vfs-bookmarks-gtk.c"
	}
}

static void
_vala_desktop_agnostic_vfs_bookmark_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	DesktopAgnosticVFSBookmark * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_BOOKMARK, DesktopAgnosticVFSBookmark);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	switch (property_id) {
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_BOOKMARK_FILE_PROPERTY:
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		desktop_agnostic_vfs_bookmark_set_file (self, g_value_get_object (value));
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_BOOKMARK_ALIAS_PROPERTY:
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		desktop_agnostic_vfs_bookmark_set_alias (self, g_value_get_string (value));
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 364 "vfs-bookmarks-gtk.c"
		default:
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 370 "vfs-bookmarks-gtk.c"
	}
}

static inline gpointer
desktop_agnostic_vfs_gtk_bookmarks_get_instance_private (DesktopAgnosticVFSGtkBookmarks* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSGtkBookmarks_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 63 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 385 "vfs-bookmarks-gtk.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 63 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 393 "vfs-bookmarks-gtk.c"
}

/**
     * Creates a new parser object.
     * @param file the object representing the gtk bookmark file. if %NULL,
     * defaults to "~/.gtk-bookmarks" (defaults to %NULL)
     * @param monitor if %TRUE, monitors the file for changes, and notifies of
     * changes via the "changed" signal (defaults to %TRUE)
     */
static void
_desktop_agnostic_vfs_gtk_bookmarks_on_file_changed_desktop_agnostic_vfs_file_monitor_changed (DesktopAgnosticVFSFileMonitor* _sender,
                                                                                               DesktopAgnosticVFSFile* file,
                                                                                               DesktopAgnosticVFSFile* other,
                                                                                               DesktopAgnosticVFSFileMonitorEvent event,
                                                                                               gpointer self)
{
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	desktop_agnostic_vfs_gtk_bookmarks_on_file_changed ((DesktopAgnosticVFSGtkBookmarks*) self, _sender, file, other, event);
#line 412 "vfs-bookmarks-gtk.c"
}

DesktopAgnosticVFSGtkBookmarks*
desktop_agnostic_vfs_gtk_bookmarks_construct (GType object_type,
                                              DesktopAgnosticVFSFile* file,
                                              gboolean monitor)
{
	DesktopAgnosticVFSGtkBookmarks * self = NULL;
	DesktopAgnosticVFSFile* _tmp0_;
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	self = (DesktopAgnosticVFSGtkBookmarks*) g_object_new (object_type, "file", file, NULL);
#line 81 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	_tmp0_ = self->priv->_file;
#line 81 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	if (desktop_agnostic_vfs_file_exists (_tmp0_)) {
#line 83 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		desktop_agnostic_vfs_gtk_bookmarks_parse (self);
#line 430 "vfs-bookmarks-gtk.c"
	}
#line 85 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	if (monitor) {
#line 434 "vfs-bookmarks-gtk.c"
		DesktopAgnosticVFSFile* _tmp1_;
		DesktopAgnosticVFSFileMonitor* _tmp2_;
		DesktopAgnosticVFSFileMonitor* _tmp3_;
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp1_ = self->priv->_file;
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp2_ = desktop_agnostic_vfs_file_monitor (_tmp1_);
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_object_unref0 (self->priv->_monitor);
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		self->priv->_monitor = _tmp2_;
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp3_ = self->priv->_monitor;
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_signal_connect_object (_tmp3_, "changed", (GCallback) _desktop_agnostic_vfs_gtk_bookmarks_on_file_changed_desktop_agnostic_vfs_file_monitor_changed, self, 0);
#line 450 "vfs-bookmarks-gtk.c"
	}
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	return self;
#line 454 "vfs-bookmarks-gtk.c"
}

DesktopAgnosticVFSGtkBookmarks*
desktop_agnostic_vfs_gtk_bookmarks_new (DesktopAgnosticVFSFile* file,
                                        gboolean monitor)
{
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	return desktop_agnostic_vfs_gtk_bookmarks_construct (DESKTOP_AGNOSTIC_VFS_TYPE_GTK_BOOKMARKS, file, monitor);
#line 463 "vfs-bookmarks-gtk.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 484 "vfs-bookmarks-gtk.c"
}

static void
desktop_agnostic_vfs_gtk_bookmarks_parse (DesktopAgnosticVFSGtkBookmarks* self)
{
	GError* _inner_error0_ = NULL;
#line 91 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_if_fail (self != NULL);
#line 94 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	(self->priv->_bookmarks == NULL) ? NULL : (self->priv->_bookmarks = (_g_slist_free__g_object_unref0_ (self->priv->_bookmarks), NULL));
#line 94 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	self->priv->_bookmarks = NULL;
#line 497 "vfs-bookmarks-gtk.c"
	{
		gchar* contents = NULL;
		gsize length = 0UL;
		gchar** lines = NULL;
		gint lines_length1 = 0;
		gint _lines_size_ = 0;
		DesktopAgnosticVFSFile* _tmp0_;
		gchar* _tmp1_ = NULL;
		gsize _tmp2_ = 0UL;
		const gchar* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp0_ = self->priv->_file;
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		desktop_agnostic_vfs_file_load_contents (_tmp0_, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_free0 (contents);
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		contents = _tmp1_;
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		length = _tmp2_;
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 102 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			_g_free0 (contents);
#line 528 "vfs-bookmarks-gtk.c"
			goto __catch0_g_error;
		}
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp3_ = contents;
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, "\n", 0);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		lines = _tmp5_;
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		lines_length1 = _vala_array_length (_tmp4_);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_lines_size_ = lines_length1;
#line 104 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp6_ = lines;
#line 104 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp6__length1 = lines_length1;
#line 547 "vfs-bookmarks-gtk.c"
		{
			gchar** line_collection = NULL;
			gint line_collection_length1 = 0;
			gint _line_collection_size_ = 0;
			gint line_it = 0;
#line 104 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			line_collection = _tmp6_;
#line 104 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			line_collection_length1 = _tmp6__length1;
#line 104 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 559 "vfs-bookmarks-gtk.c"
				const gchar* line = NULL;
#line 104 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
				line = line_collection[line_it];
#line 563 "vfs-bookmarks-gtk.c"
				{
					gchar** tokens = NULL;
					gint tokens_length1 = 0;
					gint _tokens_size_ = 0;
					const gchar* _tmp7_;
					const gchar* _tmp8_;
					gchar** _tmp9_;
					gchar** _tmp10_;
					gboolean _tmp11_ = FALSE;
					gchar** _tmp12_;
					gint _tmp12__length1;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					_tmp7_ = line;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					if (g_strcmp0 (_tmp7_, "") == 0) {
#line 110 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 110 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						continue;
#line 583 "vfs-bookmarks-gtk.c"
					}
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					_tmp8_ = line;
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, " ", 2);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					tokens = _tmp10_;
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					tokens_length1 = _vala_array_length (_tmp9_);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					_tokens_size_ = tokens_length1;
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					_tmp12_ = tokens;
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					_tmp12__length1 = tokens_length1;
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					if (_tmp12_ != NULL) {
#line 603 "vfs-bookmarks-gtk.c"
						gchar** _tmp13_;
						gint _tmp13__length1;
						const gchar* _tmp14_;
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp13_ = tokens;
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp13__length1 = tokens_length1;
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp14_ = _tmp13_[0];
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp11_ = _tmp14_ != NULL;
#line 615 "vfs-bookmarks-gtk.c"
					} else {
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp11_ = FALSE;
#line 619 "vfs-bookmarks-gtk.c"
					}
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					if (_tmp11_) {
#line 623 "vfs-bookmarks-gtk.c"
						DesktopAgnosticVFSBookmark* bookmark = NULL;
						DesktopAgnosticVFSBookmark* _tmp15_;
						gchar** _tmp16_;
						gint _tmp16__length1;
						const gchar* _tmp17_;
						gchar* _tmp18_;
						gchar* _tmp19_;
						DesktopAgnosticVFSFile* _tmp20_ = NULL;
						gchar** _tmp21_;
						gint _tmp21__length1;
						const gchar* _tmp22_;
						DesktopAgnosticVFSFile* _tmp23_;
						DesktopAgnosticVFSBookmark* _tmp24_;
						gchar** _tmp25_;
						gint _tmp25__length1;
						const gchar* _tmp26_;
						DesktopAgnosticVFSBookmark* _tmp35_;
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp15_ = desktop_agnostic_vfs_bookmark_new ();
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						bookmark = _tmp15_;
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp16_ = tokens;
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp16__length1 = tokens_length1;
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp17_ = _tmp16_[0];
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp18_ = string_strip (_tmp17_);
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp19_ = _tmp18_;
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_g_free0 (_tmp19_);
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp21_ = tokens;
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp21__length1 = tokens_length1;
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp22_ = _tmp21_[0];
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp23_ = desktop_agnostic_vfs_file_new_for_uri (_tmp22_, &_inner_error0_);
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp20_ = _tmp23_;
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_g_object_unref0 (bookmark);
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_g_free0 (contents);
#line 677 "vfs-bookmarks-gtk.c"
							goto __catch0_g_error;
						}
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp24_ = bookmark;
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						desktop_agnostic_vfs_bookmark_set_file (_tmp24_, _tmp20_);
#line 119 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp25_ = tokens;
#line 119 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp25__length1 = tokens_length1;
#line 119 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp26_ = _tmp25_[1];
#line 119 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						if (_tmp26_ == NULL) {
#line 692 "vfs-bookmarks-gtk.c"
							DesktopAgnosticVFSBookmark* _tmp27_;
#line 121 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp27_ = bookmark;
#line 121 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							desktop_agnostic_vfs_bookmark_set_alias (_tmp27_, NULL);
#line 698 "vfs-bookmarks-gtk.c"
						} else {
							gchar** _tmp28_;
							gint _tmp28__length1;
							const gchar* _tmp29_;
							gchar* _tmp30_;
							gchar* _tmp31_;
							DesktopAgnosticVFSBookmark* _tmp32_;
							gchar** _tmp33_;
							gint _tmp33__length1;
							const gchar* _tmp34_;
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp28_ = tokens;
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp28__length1 = tokens_length1;
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp29_ = _tmp28_[1];
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp30_ = string_strip (_tmp29_);
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp31_ = _tmp30_;
#line 125 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_g_free0 (_tmp31_);
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp32_ = bookmark;
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp33_ = tokens;
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp33__length1 = tokens_length1;
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							_tmp34_ = _tmp33_[1];
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
							desktop_agnostic_vfs_bookmark_set_alias (_tmp32_, _tmp34_);
#line 731 "vfs-bookmarks-gtk.c"
						}
#line 128 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_tmp35_ = bookmark;
#line 128 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						bookmark = NULL;
#line 128 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						self->priv->_bookmarks = g_slist_append (self->priv->_bookmarks, _tmp35_);
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_g_object_unref0 (_tmp20_);
#line 114 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
						_g_object_unref0 (bookmark);
#line 743 "vfs-bookmarks-gtk.c"
					}
#line 104 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 747 "vfs-bookmarks-gtk.c"
				}
			}
		}
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_free0 (contents);
#line 755 "vfs-bookmarks-gtk.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		err = _inner_error0_;
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_inner_error0_ = NULL;
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp36_ = err;
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp37_ = _tmp36_->message;
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_critical ("vfs-bookmarks-gtk.vala:134: Could not load/parse GTK bookmarks file: %" \
"s", _tmp37_);
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		(self->priv->_bookmarks == NULL) ? NULL : (self->priv->_bookmarks = (_g_slist_free__g_object_unref0_ (self->priv->_bookmarks), NULL));
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		self->priv->_bookmarks = NULL;
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_error_free0 (err);
#line 779 "vfs-bookmarks-gtk.c"
	}
	__finally0:
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_clear_error (&_inner_error0_);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		return;
#line 790 "vfs-bookmarks-gtk.c"
	}
}

static void
desktop_agnostic_vfs_gtk_bookmarks_on_file_changed (DesktopAgnosticVFSGtkBookmarks* self,
                                                    DesktopAgnosticVFSFileMonitor* monitor,
                                                    DesktopAgnosticVFSFile* file,
                                                    DesktopAgnosticVFSFile* other,
                                                    DesktopAgnosticVFSFileMonitorEvent event)
{
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_if_fail (self != NULL);
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_if_fail (monitor != NULL);
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_if_fail (file != NULL);
#line 142 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	switch (event) {
#line 142 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CREATED:
#line 142 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CHANGED:
#line 813 "vfs-bookmarks-gtk.c"
		{
#line 146 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			desktop_agnostic_vfs_gtk_bookmarks_parse (self);
#line 147 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			g_signal_emit (self, desktop_agnostic_vfs_gtk_bookmarks_signals[DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_CHANGED_SIGNAL], 0);
#line 148 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			break;
#line 821 "vfs-bookmarks-gtk.c"
		}
#line 142 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_DELETED:
#line 825 "vfs-bookmarks-gtk.c"
		{
#line 150 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			(self->priv->_bookmarks == NULL) ? NULL : (self->priv->_bookmarks = (_g_slist_free__g_object_unref0_ (self->priv->_bookmarks), NULL));
#line 150 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			self->priv->_bookmarks = NULL;
#line 151 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			g_signal_emit (self, desktop_agnostic_vfs_gtk_bookmarks_signals[DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_CHANGED_SIGNAL], 0);
#line 152 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			break;
#line 835 "vfs-bookmarks-gtk.c"
		}
		default:
		{
#line 155 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			break;
#line 841 "vfs-bookmarks-gtk.c"
		}
	}
}

static void
desktop_agnostic_vfs_gtk_bookmarks_set_file (DesktopAgnosticVFSGtkBookmarks* self,
                                             DesktopAgnosticVFSFile* value)
{
	GError* _inner_error0_ = NULL;
#line 47 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_if_fail (self != NULL);
#line 49 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	if (value == NULL) {
#line 855 "vfs-bookmarks-gtk.c"
		gchar* fname = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		DesktopAgnosticVFSFile* _tmp2_ = NULL;
		const gchar* _tmp3_;
		DesktopAgnosticVFSFile* _tmp4_;
		DesktopAgnosticVFSFile* _tmp5_;
#line 53 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp0_ = g_get_home_dir ();
#line 53 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp1_ = g_build_filename (_tmp0_, ".gtk-bookmarks", NULL);
#line 53 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_free0 (fname);
#line 53 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		fname = _tmp1_;
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp3_ = fname;
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp4_ = desktop_agnostic_vfs_file_new_for_path (_tmp3_, &_inner_error0_);
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp2_ = _tmp4_;
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			_g_free0 (fname);
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			g_clear_error (&_inner_error0_);
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
			return;
#line 887 "vfs-bookmarks-gtk.c"
		}
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp5_ = _tmp2_;
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp2_ = NULL;
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_object_unref0 (self->priv->_file);
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		self->priv->_file = _tmp5_;
#line 49 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_object_unref0 (_tmp2_);
#line 49 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_free0 (fname);
#line 901 "vfs-bookmarks-gtk.c"
	} else {
		DesktopAgnosticVFSFile* _tmp6_;
#line 59 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_tmp6_ = _g_object_ref0 (value);
#line 59 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		_g_object_unref0 (self->priv->_file);
#line 59 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		self->priv->_file = _tmp6_;
#line 910 "vfs-bookmarks-gtk.c"
	}
#line 47 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_vfs_gtk_bookmarks_properties[DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_FILE_PROPERTY]);
#line 914 "vfs-bookmarks-gtk.c"
}

GSList*
desktop_agnostic_vfs_gtk_bookmarks_get_bookmarks (DesktopAgnosticVFSGtkBookmarks* self)
{
	GSList* result;
	GSList* _tmp0_;
#line 66 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	_tmp0_ = self->priv->_bookmarks;
#line 68 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	result = _tmp0_;
#line 68 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	return result;
#line 930 "vfs-bookmarks-gtk.c"
}

static void
desktop_agnostic_vfs_gtk_bookmarks_class_init (DesktopAgnosticVFSGtkBookmarksClass * klass,
                                               gpointer klass_data)
{
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	desktop_agnostic_vfs_gtk_bookmarks_parent_class = g_type_class_peek_parent (klass);
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSGtkBookmarks_private_offset);
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_gtk_bookmarks_get_property;
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_vfs_gtk_bookmarks_set_property;
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_gtk_bookmarks_finalize;
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_FILE_PROPERTY, desktop_agnostic_vfs_gtk_bookmarks_properties[DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", DESKTOP_AGNOSTIC_VFS_TYPE_FILE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_BOOKMARKS_PROPERTY, desktop_agnostic_vfs_gtk_bookmarks_properties[DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_BOOKMARKS_PROPERTY] = g_param_spec_pointer ("bookmarks", "bookmarks", "bookmarks", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 951 "vfs-bookmarks-gtk.c"
	/**
	     * Emitted when a monitor has been created for the bookmarks file, and its
	     * contents have changed.
	     */
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	desktop_agnostic_vfs_gtk_bookmarks_signals[DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_CHANGED_SIGNAL] = g_signal_new ("changed", DESKTOP_AGNOSTIC_VFS_TYPE_GTK_BOOKMARKS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 958 "vfs-bookmarks-gtk.c"
}

static void
desktop_agnostic_vfs_gtk_bookmarks_instance_init (DesktopAgnosticVFSGtkBookmarks * self,
                                                  gpointer klass)
{
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	self->priv = desktop_agnostic_vfs_gtk_bookmarks_get_instance_private (self);
#line 967 "vfs-bookmarks-gtk.c"
}

static void
desktop_agnostic_vfs_gtk_bookmarks_finalize (GObject * obj)
{
	DesktopAgnosticVFSGtkBookmarks * self;
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_GTK_BOOKMARKS, DesktopAgnosticVFSGtkBookmarks);
#line 43 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	_g_object_unref0 (self->priv->_file);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	_g_object_unref0 (self->priv->_monitor);
#line 63 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	(self->priv->_bookmarks == NULL) ? NULL : (self->priv->_bookmarks = (_g_slist_free__g_object_unref0_ (self->priv->_bookmarks), NULL));
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_gtk_bookmarks_parent_class)->finalize (obj);
#line 984 "vfs-bookmarks-gtk.c"
}

/**
   * Parses .gtk-bookmarks files.
   */
static GType
desktop_agnostic_vfs_gtk_bookmarks_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSGtkBookmarksClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_gtk_bookmarks_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSGtkBookmarks), 0, (GInstanceInitFunc) desktop_agnostic_vfs_gtk_bookmarks_instance_init, NULL };
	GType desktop_agnostic_vfs_gtk_bookmarks_type_id;
	desktop_agnostic_vfs_gtk_bookmarks_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSGtkBookmarks", &g_define_type_info, 0);
	DesktopAgnosticVFSGtkBookmarks_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_gtk_bookmarks_type_id, sizeof (DesktopAgnosticVFSGtkBookmarksPrivate));
	return desktop_agnostic_vfs_gtk_bookmarks_type_id;
}

GType
desktop_agnostic_vfs_gtk_bookmarks_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_gtk_bookmarks_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_gtk_bookmarks_type_id__once)) {
		GType desktop_agnostic_vfs_gtk_bookmarks_type_id;
		desktop_agnostic_vfs_gtk_bookmarks_type_id = desktop_agnostic_vfs_gtk_bookmarks_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_gtk_bookmarks_type_id__once, desktop_agnostic_vfs_gtk_bookmarks_type_id);
	}
	return desktop_agnostic_vfs_gtk_bookmarks_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_gtk_bookmarks_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	DesktopAgnosticVFSGtkBookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_GTK_BOOKMARKS, DesktopAgnosticVFSGtkBookmarks);
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	switch (property_id) {
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_BOOKMARKS_PROPERTY:
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		g_value_set_pointer (value, desktop_agnostic_vfs_gtk_bookmarks_get_bookmarks (self));
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 1028 "vfs-bookmarks-gtk.c"
		default:
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 1034 "vfs-bookmarks-gtk.c"
	}
}

static void
_vala_desktop_agnostic_vfs_gtk_bookmarks_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	DesktopAgnosticVFSGtkBookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_GTK_BOOKMARKS, DesktopAgnosticVFSGtkBookmarks);
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
	switch (property_id) {
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		case DESKTOP_AGNOSTIC_VFS_GTK_BOOKMARKS_FILE_PROPERTY:
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		desktop_agnostic_vfs_gtk_bookmarks_set_file (self, g_value_get_object (value));
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 1054 "vfs-bookmarks-gtk.c"
		default:
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-bookmarks-gtk.vala"
		break;
#line 1060 "vfs-bookmarks-gtk.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1071 "vfs-bookmarks-gtk.c"
		gssize i;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1079 "vfs-bookmarks-gtk.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
	g_free (array);
#line 1094 "vfs-bookmarks-gtk.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
	if (array) {
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
		while (((gpointer*) array)[length]) {
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
			length++;
#line 1108 "vfs-bookmarks-gtk.c"
		}
	}
#line 44 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs.vala"
	return length;
#line 1113 "vfs-bookmarks-gtk.c"
}

