/* vfs-glob.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-glob.vala, do not modify */

/*
 * Desktop Agnostic Library: glob() wrapper.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "desktop-agnostic-vfs.h"
#include <glob.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <errno.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_GLOB_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GLOB_OFFSET_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GLOB_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_glob_properties[DESKTOP_AGNOSTIC_VFS_GLOB_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DesktopAgnosticVFSGlobPrivate {
	glob_t glob;
	gchar* _pattern;
	gint _flags;
};

static gint DesktopAgnosticVFSGlob_private_offset;
static gpointer desktop_agnostic_vfs_glob_parent_class = NULL;

static void desktop_agnostic_vfs_glob_run_glob (DesktopAgnosticVFSGlob* self,
                                         const gchar* pattern,
                                         gint flags,
                                         GError** error);
static gint desktop_agnostic_vfs_glob_on_glob_error (const gchar* path,
                                              gint eerrno);
static void desktop_agnostic_vfs_glob_finalize (GObject * obj);
static GType desktop_agnostic_vfs_glob_get_type_once (void);
static void _vala_desktop_agnostic_vfs_glob_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_desktop_agnostic_vfs_glob_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

GQuark
desktop_agnostic_vfs_glob_error_quark (void)
{
#line 237 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-file.vala"
	return g_quark_from_static_string ("desktop-agnostic-vfs-glob-error-quark");
#line 86 "vfs-glob.c"
}

static GType
desktop_agnostic_vfs_glob_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOSPACE, "DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOSPACE", "nospace"}, {DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ABORTED, "DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ABORTED", "aborted"}, {DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH, "DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH", "nomatch"}, {DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_PATTERN, "DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_PATTERN", "bad-pattern"}, {DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_FLAGS, "DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_FLAGS", "bad-flags"}, {DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ERRNO, "DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ERRNO", "errno"}, {0, NULL, NULL}};
	GType desktop_agnostic_vfs_glob_error_type_id;
	desktop_agnostic_vfs_glob_error_type_id = g_enum_register_static ("DesktopAgnosticVFSGlobError", values);
	return desktop_agnostic_vfs_glob_error_type_id;
}

GType
desktop_agnostic_vfs_glob_error_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_glob_error_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_glob_error_type_id__once)) {
		GType desktop_agnostic_vfs_glob_error_type_id;
		desktop_agnostic_vfs_glob_error_type_id = desktop_agnostic_vfs_glob_error_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_glob_error_type_id__once, desktop_agnostic_vfs_glob_error_type_id);
	}
	return desktop_agnostic_vfs_glob_error_type_id__once;
}

static inline gpointer
desktop_agnostic_vfs_glob_get_instance_private (DesktopAgnosticVFSGlob* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSGlob_private_offset);
}

DesktopAgnosticVFSGlob*
desktop_agnostic_vfs_glob_execute (const gchar* pattern,
                                   GError** error)
{
	DesktopAgnosticVFSGlob* g = NULL;
	GObject* _tmp0_;
	GObject* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticVFSGlob* result;
#line 84 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_val_if_fail (pattern != NULL, NULL);
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp0_ = g_object_new (DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, "pattern", pattern, NULL);
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 87 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp2_ = g->priv->_pattern;
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	desktop_agnostic_vfs_glob_run_glob (g, _tmp2_, g->priv->_flags, &_inner_error0_);
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_propagate_error (error, _inner_error0_);
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			_g_object_unref0 (g);
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			return NULL;
#line 148 "vfs-glob.c"
		} else {
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			_g_object_unref0 (g);
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_clear_error (&_inner_error0_);
#line 88 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			return NULL;
#line 158 "vfs-glob.c"
		}
	}
#line 89 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	result = g;
#line 89 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return result;
#line 165 "vfs-glob.c"
}

DesktopAgnosticVFSGlob*
desktop_agnostic_vfs_glob_execute_with_flags (const gchar* pattern,
                                              gint flags,
                                              GError** error)
{
	DesktopAgnosticVFSGlob* g = NULL;
	GObject* _tmp0_;
	GObject* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	DesktopAgnosticVFSGlob* result;
#line 91 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_val_if_fail (pattern != NULL, NULL);
#line 94 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp0_ = g_object_new (DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, "pattern", pattern, "flags", flags, NULL);
#line 94 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
#line 94 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp2_ = g->priv->_pattern;
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	desktop_agnostic_vfs_glob_run_glob (g, _tmp2_, g->priv->_flags, &_inner_error0_);
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_propagate_error (error, _inner_error0_);
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			_g_object_unref0 (g);
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			return NULL;
#line 201 "vfs-glob.c"
		} else {
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			_g_object_unref0 (g);
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_clear_error (&_inner_error0_);
#line 97 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			return NULL;
#line 211 "vfs-glob.c"
		}
	}
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	result = g;
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return result;
#line 218 "vfs-glob.c"
}

void
desktop_agnostic_vfs_glob_append (DesktopAgnosticVFSGlob* self,
                                  const gchar* pattern,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_if_fail (self != NULL);
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_if_fail (pattern != NULL);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	desktop_agnostic_vfs_glob_run_glob (self, pattern, self->priv->_flags | GLOB_APPEND, &_inner_error0_);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_propagate_error (error, _inner_error0_);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			return;
#line 241 "vfs-glob.c"
		} else {
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_clear_error (&_inner_error0_);
#line 103 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			return;
#line 249 "vfs-glob.c"
		}
	}
}

gchar**
desktop_agnostic_vfs_glob_get_paths (DesktopAgnosticVFSGlob* self,
                                     gint* result_length1)
{
	glob_t _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** result;
#line 105 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp0_ = self->priv->glob;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp1_ = _tmp0_.gl_pathv;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp1__length1 = _tmp0_.gl_pathc;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp2_ = _tmp1_;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp2__length1 = _tmp1__length1;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	if (result_length1) {
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		*result_length1 = _tmp2__length1;
#line 280 "vfs-glob.c"
	}
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	result = _tmp2_;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return result;
#line 286 "vfs-glob.c"
}

static void
desktop_agnostic_vfs_glob_run_glob (DesktopAgnosticVFSGlob* self,
                                    const gchar* pattern,
                                    gint flags,
                                    GError** error)
{
	gint res = 0;
	glob_t _tmp0_ = {0};
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
#line 110 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_if_fail (self != NULL);
#line 110 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_if_fail (pattern != NULL);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp1_ = glob (pattern, flags, (void*) desktop_agnostic_vfs_glob_on_glob_error, &_tmp0_);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	globfree (&self->priv->glob);
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	self->priv->glob = _tmp0_;
#line 113 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	res = _tmp1_;
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	if (res != 0) {
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		switch (res) {
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			case GLOB_NOSPACE:
#line 317 "vfs-glob.c"
			{
				GError* _tmp2_;
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				_tmp2_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOSPACE, "Ran out of memory.");
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				_inner_error0_ = _tmp2_;
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_propagate_error (error, _inner_error0_);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					return;
#line 330 "vfs-glob.c"
				} else {
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_clear_error (&_inner_error0_);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					return;
#line 338 "vfs-glob.c"
				}
			}
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			case GLOB_ABORTED:
#line 343 "vfs-glob.c"
			{
				GError* _tmp3_;
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				_tmp3_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ABORTED, "Read error.");
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				_inner_error0_ = _tmp3_;
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_propagate_error (error, _inner_error0_);
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					return;
#line 356 "vfs-glob.c"
				} else {
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_clear_error (&_inner_error0_);
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					return;
#line 364 "vfs-glob.c"
				}
			}
#line 117 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			case GLOB_NOMATCH:
#line 369 "vfs-glob.c"
			{
				GError* _tmp4_;
#line 124 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				_tmp4_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH, "No matches found.");
#line 124 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				_inner_error0_ = _tmp4_;
#line 124 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				if (_inner_error0_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
#line 124 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_propagate_error (error, _inner_error0_);
#line 124 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					return;
#line 382 "vfs-glob.c"
				} else {
#line 124 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					g_clear_error (&_inner_error0_);
#line 124 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
					return;
#line 390 "vfs-glob.c"
				}
			}
			default:
			{
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				g_critical ("vfs-glob.vala:126: Unknown error code: %d", res);
#line 127 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
				break;
#line 399 "vfs-glob.c"
			}
		}
	}
}

static gint
desktop_agnostic_vfs_glob_on_glob_error (const gchar* path,
                                         gint eerrno)
{
	GError* _inner_error0_ = NULL;
	gint result;
#line 131 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_val_if_fail (path != NULL, 0);
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	switch (eerrno) {
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case EACCES:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case EBADF:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case EMFILE:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case ENFILE:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case ENOENT:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case ENOMEM:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case ENOTDIR:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case EFAULT:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case EINVAL:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case ELOOP:
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case ENAMETOOLONG:
#line 437 "vfs-glob.c"
		{
			const gchar* _tmp0_;
			GError* _tmp1_;
			gint _tmp2_ = -1;
#line 147 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			_tmp0_ = strerror (eerrno);
#line 147 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			_tmp1_ = g_error_new (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ERRNO, "Miscellaneous error for '%s' (%d): %s", path, eerrno, _tmp0_);
#line 147 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			_inner_error0_ = _tmp1_;
#line 147 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_clear_error (&_inner_error0_);
#line 147 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			return _tmp2_;
#line 454 "vfs-glob.c"
		}
		default:
		{
#line 151 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			g_critical ("vfs-glob.vala:151: Unknown error code: %d", eerrno);
#line 152 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
			break;
#line 462 "vfs-glob.c"
		}
	}
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	result = 1;
#line 154 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return result;
#line 469 "vfs-glob.c"
}

DesktopAgnosticVFSGlob*
desktop_agnostic_vfs_glob_construct (GType object_type)
{
	DesktopAgnosticVFSGlob * self = NULL;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	self = (DesktopAgnosticVFSGlob*) g_object_new (object_type, NULL);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return self;
#line 480 "vfs-glob.c"
}

DesktopAgnosticVFSGlob*
desktop_agnostic_vfs_glob_new (void)
{
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return desktop_agnostic_vfs_glob_construct (DESKTOP_AGNOSTIC_VFS_TYPE_GLOB);
#line 488 "vfs-glob.c"
}

gsize
desktop_agnostic_vfs_glob_get_offset (DesktopAgnosticVFSGlob* self)
{
	gsize result;
	glob_t _tmp0_;
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 43 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp0_ = self->priv->glob;
#line 43 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	result = _tmp0_.gl_offs;
#line 43 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return result;
#line 504 "vfs-glob.c"
}

const gchar*
desktop_agnostic_vfs_glob_get_pattern (DesktopAgnosticVFSGlob* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_tmp0_ = self->priv->_pattern;
#line 51 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	result = _tmp0_;
#line 51 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return result;
#line 520 "vfs-glob.c"
}

void
desktop_agnostic_vfs_glob_set_pattern (DesktopAgnosticVFSGlob* self,
                                       const gchar* value)
{
	GError* _inner_error0_ = NULL;
#line 53 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_if_fail (self != NULL);
#line 55 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	if (g_strcmp0 (value, "") != 0) {
#line 532 "vfs-glob.c"
		gchar* _tmp0_;
#line 57 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		_tmp0_ = g_strdup (value);
#line 57 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		_g_free0 (self->priv->_pattern);
#line 57 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		self->priv->_pattern = _tmp0_;
#line 540 "vfs-glob.c"
	} else {
		GError* _tmp1_;
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		_tmp1_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_PATTERN, "Invalid pattern.");
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		_inner_error0_ = _tmp1_;
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		g_clear_error (&_inner_error0_);
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		return;
#line 553 "vfs-glob.c"
	}
#line 53 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_vfs_glob_properties[DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN_PROPERTY]);
#line 557 "vfs-glob.c"
}

gint
desktop_agnostic_vfs_glob_get_flags (DesktopAgnosticVFSGlob* self)
{
	gint result;
#line 68 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 70 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	result = self->priv->_flags;
#line 70 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	return result;
#line 570 "vfs-glob.c"
}

void
desktop_agnostic_vfs_glob_set_flags (DesktopAgnosticVFSGlob* self,
                                     gint value)
{
	GError* _inner_error0_ = NULL;
#line 72 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_return_if_fail (self != NULL);
#line 74 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	if (value >= 0) {
#line 76 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		self->priv->_flags = value;
#line 584 "vfs-glob.c"
	} else {
		GError* _tmp0_;
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		_tmp0_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_FLAGS, "Invalid flags.");
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		_inner_error0_ = _tmp0_;
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		g_clear_error (&_inner_error0_);
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		return;
#line 597 "vfs-glob.c"
	}
#line 72 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_object_notify_by_pspec ((GObject *) self, desktop_agnostic_vfs_glob_properties[DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS_PROPERTY]);
#line 601 "vfs-glob.c"
}

static void
desktop_agnostic_vfs_glob_class_init (DesktopAgnosticVFSGlobClass * klass,
                                      gpointer klass_data)
{
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	desktop_agnostic_vfs_glob_parent_class = g_type_class_peek_parent (klass);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSGlob_private_offset);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_glob_get_property;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_vfs_glob_set_property;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_glob_finalize;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GLOB_OFFSET_PROPERTY, desktop_agnostic_vfs_glob_properties[DESKTOP_AGNOSTIC_VFS_GLOB_OFFSET_PROPERTY] = g_param_spec_ulong ("offset", "offset", "offset", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN_PROPERTY, desktop_agnostic_vfs_glob_properties[DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN_PROPERTY] = g_param_spec_string ("pattern", "pattern", "pattern", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS_PROPERTY, desktop_agnostic_vfs_glob_properties[DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS_PROPERTY] = g_param_spec_int ("flags", "flags", "flags", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 624 "vfs-glob.c"
}

static void
desktop_agnostic_vfs_glob_instance_init (DesktopAgnosticVFSGlob * self,
                                         gpointer klass)
{
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	self->priv = desktop_agnostic_vfs_glob_get_instance_private (self);
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	self->priv->_flags = (GLOB_MARK | GLOB_BRACE) | GLOB_TILDE_CHECK;
#line 635 "vfs-glob.c"
}

static void
desktop_agnostic_vfs_glob_finalize (GObject * obj)
{
	DesktopAgnosticVFSGlob * self;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
#line 38 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	globfree (&self->priv->glob);
#line 46 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	_g_free0 (self->priv->_pattern);
#line 91 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_glob_parent_class)->finalize (obj);
#line 650 "vfs-glob.c"
}

static GType
desktop_agnostic_vfs_glob_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSGlobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_glob_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSGlob), 0, (GInstanceInitFunc) desktop_agnostic_vfs_glob_instance_init, NULL };
	GType desktop_agnostic_vfs_glob_type_id;
	desktop_agnostic_vfs_glob_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSGlob", &g_define_type_info, 0);
	DesktopAgnosticVFSGlob_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_glob_type_id, sizeof (DesktopAgnosticVFSGlobPrivate));
	return desktop_agnostic_vfs_glob_type_id;
}

GType
desktop_agnostic_vfs_glob_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_glob_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_glob_type_id__once)) {
		GType desktop_agnostic_vfs_glob_type_id;
		desktop_agnostic_vfs_glob_type_id = desktop_agnostic_vfs_glob_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_glob_type_id__once, desktop_agnostic_vfs_glob_type_id);
	}
	return desktop_agnostic_vfs_glob_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_glob_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	DesktopAgnosticVFSGlob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	switch (property_id) {
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case DESKTOP_AGNOSTIC_VFS_GLOB_OFFSET_PROPERTY:
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		g_value_set_ulong (value, desktop_agnostic_vfs_glob_get_offset (self));
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		break;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN_PROPERTY:
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		g_value_set_string (value, desktop_agnostic_vfs_glob_get_pattern (self));
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		break;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS_PROPERTY:
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		g_value_set_int (value, desktop_agnostic_vfs_glob_get_flags (self));
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		break;
#line 703 "vfs-glob.c"
		default:
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		break;
#line 709 "vfs-glob.c"
	}
}

static void
_vala_desktop_agnostic_vfs_glob_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	DesktopAgnosticVFSGlob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
	switch (property_id) {
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN_PROPERTY:
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		desktop_agnostic_vfs_glob_set_pattern (self, g_value_get_string (value));
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		break;
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		case DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS_PROPERTY:
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		desktop_agnostic_vfs_glob_set_flags (self, g_value_get_int (value));
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		break;
#line 735 "vfs-glob.c"
		default:
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-glob.vala"
		break;
#line 741 "vfs-glob.c"
	}
}

