/* vfs-trash-impl-gio.c generated by valac 0.56.17, the Vala compiler
 * generated from vfs-trash-impl-gio.vala, do not modify */

/*
 * Desktop Agnostic Library: Trash implementation with GIO.
 *
 * Copyright (C) 2008, 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include "da-vfs-gio.h"
#include <desktop-agnostic-vfs.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DESKTOP_AGNOSTIC_VFS_TRASH_GIO_0_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_TRASH_GIO_FILE_COUNT_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_TRASH_GIO_NUM_PROPERTIES
};
static GParamSpec* desktop_agnostic_vfs_trash_gio_properties[DESKTOP_AGNOSTIC_VFS_TRASH_GIO_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DesktopAgnosticVFSTrashGIOPrivate {
	DesktopAgnosticVFSFile* trash;
	DesktopAgnosticVFSFileMonitor* monitor;
	guint _file_count;
};

static gint DesktopAgnosticVFSTrashGIO_private_offset;
static gpointer desktop_agnostic_vfs_trash_gio_parent_class = NULL;
static DesktopAgnosticVFSTrashIface * desktop_agnostic_vfs_trash_gio_desktop_agnostic_vfs_trash_parent_iface = NULL;

static void desktop_agnostic_vfs_trash_gio_on_trash_changed (DesktopAgnosticVFSTrashGIO* self,
                                                      DesktopAgnosticVFSFileMonitor* monitor,
                                                      DesktopAgnosticVFSFile* file,
                                                      DesktopAgnosticVFSFile* other_file,
                                                      DesktopAgnosticVFSFileMonitorEvent event_type);
static void desktop_agnostic_vfs_trash_gio_update_file_count (DesktopAgnosticVFSTrashGIO* self);
static void desktop_agnostic_vfs_trash_gio_on_trash_count (DesktopAgnosticVFSTrashGIO* self,
                                                    GObject* obj,
                                                    GAsyncResult* res);
static void _desktop_agnostic_vfs_trash_gio_on_trash_count_gasync_ready_callback (GObject* source_object,
                                                                           GAsyncResult* res,
                                                                           gpointer self);
static void desktop_agnostic_vfs_trash_gio_do_empty (DesktopAgnosticVFSTrashGIO* self,
                                              GFile* dir);
static void desktop_agnostic_vfs_trash_gio_real_send_to_trash (DesktopAgnosticVFSTrash* base,
                                                        DesktopAgnosticVFSFile* uri,
                                                        GError** error);
static void desktop_agnostic_vfs_trash_gio_real_empty (DesktopAgnosticVFSTrash* base);
static GObject * desktop_agnostic_vfs_trash_gio_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _desktop_agnostic_vfs_trash_gio_on_trash_changed_desktop_agnostic_vfs_file_monitor_changed (DesktopAgnosticVFSFileMonitor* _sender,
                                                                                                 DesktopAgnosticVFSFile* file,
                                                                                                 DesktopAgnosticVFSFile* other,
                                                                                                 DesktopAgnosticVFSFileMonitorEvent event,
                                                                                                 gpointer self);
static void desktop_agnostic_vfs_trash_gio_finalize (GObject * obj);
static GType desktop_agnostic_vfs_trash_gio_get_type_once (void);
static void _vala_desktop_agnostic_vfs_trash_gio_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
desktop_agnostic_vfs_trash_gio_get_instance_private (DesktopAgnosticVFSTrashGIO* self)
{
	return G_STRUCT_MEMBER_P (self, DesktopAgnosticVFSTrashGIO_private_offset);
}

static void
desktop_agnostic_vfs_trash_gio_on_trash_changed (DesktopAgnosticVFSTrashGIO* self,
                                                 DesktopAgnosticVFSFileMonitor* monitor,
                                                 DesktopAgnosticVFSFile* file,
                                                 DesktopAgnosticVFSFile* other_file,
                                                 DesktopAgnosticVFSFileMonitorEvent event_type)
{
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (monitor != NULL);
#line 52 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (file != NULL);
#line 58 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	desktop_agnostic_vfs_trash_gio_update_file_count (self);
#line 118 "vfs-trash-impl-gio.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	return self ? g_object_ref (self) : NULL;
#line 126 "vfs-trash-impl-gio.c"
}

static void
_desktop_agnostic_vfs_trash_gio_on_trash_count_gasync_ready_callback (GObject* source_object,
                                                                      GAsyncResult* res,
                                                                      gpointer self)
{
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	desktop_agnostic_vfs_trash_gio_on_trash_count ((DesktopAgnosticVFSTrashGIO*) self, source_object, res);
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_object_unref (self);
#line 138 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_update_file_count (DesktopAgnosticVFSTrashGIO* self)
{
	GFile* dir = NULL;
	DesktopAgnosticVFSFile* _tmp0_;
	void* _tmp1_;
	void* _tmp2_;
	GFile* _tmp3_;
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp0_ = self->priv->trash;
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp1_ = desktop_agnostic_vfs_file_get_implementation (_tmp0_);
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp2_ = _tmp1_;
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_file_get_type (), GFile));
#line 64 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	dir = _tmp3_;
#line 65 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_file_query_info_async (dir, G_FILE_ATTRIBUTE_TRASH_ITEM_COUNT, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, _desktop_agnostic_vfs_trash_gio_on_trash_count_gasync_ready_callback, g_object_ref (self));
#line 61 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (dir);
#line 165 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_on_trash_count (DesktopAgnosticVFSTrashGIO* self,
                                               GObject* obj,
                                               GAsyncResult* res)
{
	GFile* dir = NULL;
	GFile* _tmp0_;
	GFileInfo* file_info = NULL;
	GError* _inner_error0_ = NULL;
#line 72 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 72 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (res != NULL);
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, g_file_get_type (), GFile));
#line 75 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	dir = _tmp0_;
#line 185 "vfs-trash-impl-gio.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp2_ = g_file_query_info_finish (dir, res, &_inner_error0_);
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp1_ = _tmp2_;
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "vfs-trash-impl-gio.c"
			goto __catch0_g_error;
		}
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp3_ = _tmp1_;
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp1_ = NULL;
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (file_info);
#line 80 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		file_info = _tmp3_;
#line 81 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp4_ = file_info;
#line 81 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		self->priv->_file_count = (guint) g_file_info_get_attribute_uint32 (_tmp4_, G_FILE_ATTRIBUTE_TRASH_ITEM_COUNT);
#line 82 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_signal_emit_by_name ((DesktopAgnosticVFSTrash*) self, "file-count-changed");
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (_tmp1_);
#line 216 "vfs-trash-impl-gio.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		err = _inner_error0_;
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_inner_error0_ = NULL;
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp5_ = err;
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp6_ = _tmp5_->message;
#line 86 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_warning ("vfs-trash-impl-gio.vala:86: Could not update file count: %s", _tmp6_);
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_error_free0 (err);
#line 236 "vfs-trash-impl-gio.c"
	}
	__finally0:
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (file_info);
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (dir);
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_clear_error (&_inner_error0_);
#line 78 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		return;
#line 251 "vfs-trash-impl-gio.c"
	}
#line 72 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (file_info);
#line 72 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (dir);
#line 257 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_do_empty (DesktopAgnosticVFSTrashGIO* self,
                                         GFile* dir)
{
	GFileEnumerator* files = NULL;
	GFileInfo* info = NULL;
	GFileEnumerator* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 90 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (self != NULL);
#line 90 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (dir != NULL);
#line 93 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	files = NULL;
#line 274 "vfs-trash-impl-gio.c"
	{
		gchar* attrs = NULL;
		gchar* _tmp0_;
		GFileEnumerator* _tmp1_ = NULL;
		const gchar* _tmp2_;
		GFileEnumerator* _tmp3_;
		GFileEnumerator* _tmp4_;
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp0_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 98 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		attrs = _tmp0_;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp2_ = attrs;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp3_ = g_file_enumerate_children (dir, _tmp2_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp1_ = _tmp3_;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_free0 (attrs);
#line 296 "vfs-trash-impl-gio.c"
			goto __catch0_g_error;
		}
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp4_ = _tmp1_;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp1_ = NULL;
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (files);
#line 100 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		files = _tmp4_;
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (_tmp1_);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_free0 (attrs);
#line 311 "vfs-trash-impl-gio.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		e = _inner_error0_;
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_inner_error0_ = NULL;
#line 106 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp5_ = e;
#line 106 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp6_ = _tmp5_->message;
#line 106 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_warning ("vfs-trash-impl-gio.vala:106: Trash error: %s", _tmp6_);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_error_free0 (e);
#line 331 "vfs-trash-impl-gio.c"
	}
	__finally0:
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (info);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (files);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_clear_error (&_inner_error0_);
#line 96 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		return;
#line 346 "vfs-trash-impl-gio.c"
	}
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp7_ = files;
#line 108 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	if (_tmp7_ == NULL) {
#line 110 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (info);
#line 110 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (files);
#line 110 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		return;
#line 358 "vfs-trash-impl-gio.c"
	}
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	while (TRUE) {
#line 362 "vfs-trash-impl-gio.c"
		GFileInfo* _tmp8_ = NULL;
		GFileEnumerator* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		GFile* child = NULL;
		GFileInfo* _tmp13_;
		const gchar* _tmp14_;
		GFile* _tmp15_;
		GFileInfo* _tmp16_;
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp9_ = files;
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp10_ = g_file_enumerator_next_file (_tmp9_, NULL, &_inner_error0_);
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp8_ = _tmp10_;
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_object_unref0 (info);
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_object_unref0 (files);
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			return;
#line 391 "vfs-trash-impl-gio.c"
		}
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp11_ = _tmp8_;
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp8_ = NULL;
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (info);
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		info = _tmp11_;
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp12_ = info;
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		if (!(_tmp12_ != NULL)) {
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_object_unref0 (_tmp8_);
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			break;
#line 409 "vfs-trash-impl-gio.c"
		}
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp13_ = info;
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp14_ = g_file_info_get_name (_tmp13_);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp15_ = g_file_get_child (dir, _tmp14_);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (child);
#line 115 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		child = _tmp15_;
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_tmp16_ = info;
#line 116 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		if (g_file_info_get_file_type (_tmp16_) == G_FILE_TYPE_DIRECTORY) {
#line 425 "vfs-trash-impl-gio.c"
			GFile* _tmp17_;
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_tmp17_ = child;
#line 118 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			desktop_agnostic_vfs_trash_gio_do_empty (self, _tmp17_);
#line 431 "vfs-trash-impl-gio.c"
		}
		{
			GFile* _tmp18_;
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_tmp18_ = child;
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			g_file_delete (_tmp18_, NULL, &_inner_error0_);
#line 122 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 441 "vfs-trash-impl-gio.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			e = _inner_error0_;
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_inner_error0_ = NULL;
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_tmp19_ = e;
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_tmp20_ = _tmp19_->message;
#line 126 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			g_warning ("vfs-trash-impl-gio.vala:126: Trash error: %s", _tmp20_);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_error_free0 (e);
#line 463 "vfs-trash-impl-gio.c"
		}
		__finally1:
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_object_unref0 (child);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_object_unref0 (_tmp8_);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_object_unref0 (info);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			_g_object_unref0 (files);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			g_clear_error (&_inner_error0_);
#line 120 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
			return;
#line 482 "vfs-trash-impl-gio.c"
		}
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (child);
#line 112 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (_tmp8_);
#line 488 "vfs-trash-impl-gio.c"
	}
#line 90 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (info);
#line 90 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (files);
#line 494 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_real_send_to_trash (DesktopAgnosticVFSTrash* base,
                                                   DesktopAgnosticVFSFile* uri,
                                                   GError** error)
{
	DesktopAgnosticVFSTrashGIO * self;
	GFile* file = NULL;
	void* _tmp0_;
	void* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 131 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self = (DesktopAgnosticVFSTrashGIO*) base;
#line 131 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_return_if_fail (uri != NULL);
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp0_ = desktop_agnostic_vfs_file_get_implementation (uri);
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp1_ = _tmp0_;
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_file_get_type (), GFile));
#line 134 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	file = _tmp2_;
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_file_trash (file, NULL, &_inner_error0_);
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_propagate_error (error, _inner_error0_);
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		_g_object_unref0 (file);
#line 135 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		return;
#line 530 "vfs-trash-impl-gio.c"
	}
#line 131 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (file);
#line 534 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_real_empty (DesktopAgnosticVFSTrash* base)
{
	DesktopAgnosticVFSTrashGIO * self;
	DesktopAgnosticVFSFile* _tmp0_;
	void* _tmp1_;
	void* _tmp2_;
#line 138 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self = (DesktopAgnosticVFSTrashGIO*) base;
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp0_ = self->priv->trash;
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp1_ = desktop_agnostic_vfs_file_get_implementation (_tmp0_);
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp2_ = _tmp1_;
#line 141 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	desktop_agnostic_vfs_trash_gio_do_empty (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_file_get_type (), GFile));
#line 554 "vfs-trash-impl-gio.c"
}

DesktopAgnosticVFSTrashGIO*
desktop_agnostic_vfs_trash_gio_construct (GType object_type)
{
	DesktopAgnosticVFSTrashGIO * self = NULL;
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self = (DesktopAgnosticVFSTrashGIO*) g_object_new (object_type, NULL);
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	return self;
#line 565 "vfs-trash-impl-gio.c"
}

DesktopAgnosticVFSTrashGIO*
desktop_agnostic_vfs_trash_gio_new (void)
{
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	return desktop_agnostic_vfs_trash_gio_construct (DESKTOP_AGNOSTIC_VFS_TYPE_TRASH_GIO);
#line 573 "vfs-trash-impl-gio.c"
}

static guint
desktop_agnostic_vfs_trash_gio_real_get_file_count (DesktopAgnosticVFSTrash* base)
{
	guint result;
	DesktopAgnosticVFSTrashGIO* self;
#line 46 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self = (DesktopAgnosticVFSTrashGIO*) base;
#line 48 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	result = self->priv->_file_count;
#line 48 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	return result;
#line 587 "vfs-trash-impl-gio.c"
}

static void
_desktop_agnostic_vfs_trash_gio_on_trash_changed_desktop_agnostic_vfs_file_monitor_changed (DesktopAgnosticVFSFileMonitor* _sender,
                                                                                            DesktopAgnosticVFSFile* file,
                                                                                            DesktopAgnosticVFSFile* other,
                                                                                            DesktopAgnosticVFSFileMonitorEvent event,
                                                                                            gpointer self)
{
#line 39 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	desktop_agnostic_vfs_trash_gio_on_trash_changed ((DesktopAgnosticVFSTrashGIO*) self, _sender, file, other, event);
#line 599 "vfs-trash-impl-gio.c"
}

static GObject *
desktop_agnostic_vfs_trash_gio_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DesktopAgnosticVFSTrashGIO * self;
	DesktopAgnosticVFSFile* _tmp0_ = NULL;
	DesktopAgnosticVFSFile* _tmp1_;
	DesktopAgnosticVFSFile* _tmp2_;
	DesktopAgnosticVFSFile* _tmp3_;
	DesktopAgnosticVFSFile* _tmp4_;
	DesktopAgnosticVFSFileMonitor* _tmp5_;
	DesktopAgnosticVFSFileMonitor* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 31 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	parent_class = G_OBJECT_CLASS (desktop_agnostic_vfs_trash_gio_parent_class);
#line 31 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_TRASH_GIO, DesktopAgnosticVFSTrashGIO);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp1_ = desktop_agnostic_vfs_file_new_for_uri ("trash://", &_inner_error0_);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp0_ = _tmp1_;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_clear_error (&_inner_error0_);
#line 634 "vfs-trash-impl-gio.c"
	}
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp2_ = _tmp0_;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp0_ = NULL;
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (self->priv->trash);
#line 33 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self->priv->trash = _tmp2_;
#line 34 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp3_ = self->priv->trash;
#line 34 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	if (_tmp3_ == NULL) {
#line 36 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_critical ("vfs-trash-impl-gio.vala:36: trash is NULL!!!!");
#line 650 "vfs-trash-impl-gio.c"
	}
#line 38 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp4_ = self->priv->trash;
#line 38 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp5_ = desktop_agnostic_vfs_file_monitor (_tmp4_);
#line 38 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (self->priv->monitor);
#line 38 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self->priv->monitor = _tmp5_;
#line 39 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_tmp6_ = self->priv->monitor;
#line 39 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_signal_connect_object (_tmp6_, "changed", (GCallback) _desktop_agnostic_vfs_trash_gio_on_trash_changed_desktop_agnostic_vfs_file_monitor_changed, self, 0);
#line 40 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self->priv->_file_count = (guint) 0;
#line 41 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	desktop_agnostic_vfs_trash_gio_update_file_count (self);
#line 31 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (_tmp0_);
#line 31 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	return obj;
#line 672 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_class_init (DesktopAgnosticVFSTrashGIOClass * klass,
                                           gpointer klass_data)
{
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	desktop_agnostic_vfs_trash_gio_parent_class = g_type_class_peek_parent (klass);
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_type_class_adjust_private_offset (klass, &DesktopAgnosticVFSTrashGIO_private_offset);
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_trash_gio_get_property;
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	G_OBJECT_CLASS (klass)->constructor = desktop_agnostic_vfs_trash_gio_constructor;
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_trash_gio_finalize;
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_TRASH_GIO_FILE_COUNT_PROPERTY, desktop_agnostic_vfs_trash_gio_properties[DESKTOP_AGNOSTIC_VFS_TRASH_GIO_FILE_COUNT_PROPERTY] = g_param_spec_uint ("file-count", "file-count", "file-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 691 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_desktop_agnostic_vfs_trash_interface_init (DesktopAgnosticVFSTrashIface * iface,
                                                                          gpointer iface_data)
{
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	desktop_agnostic_vfs_trash_gio_desktop_agnostic_vfs_trash_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	iface->send_to_trash = (void (*) (DesktopAgnosticVFSTrash*, DesktopAgnosticVFSFile*, GError**)) desktop_agnostic_vfs_trash_gio_real_send_to_trash;
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	iface->empty = (void (*) (DesktopAgnosticVFSTrash*)) desktop_agnostic_vfs_trash_gio_real_empty;
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	iface->get_file_count = desktop_agnostic_vfs_trash_gio_real_get_file_count;
#line 706 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_instance_init (DesktopAgnosticVFSTrashGIO * self,
                                              gpointer klass)
{
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self->priv = desktop_agnostic_vfs_trash_gio_get_instance_private (self);
#line 715 "vfs-trash-impl-gio.c"
}

static void
desktop_agnostic_vfs_trash_gio_finalize (GObject * obj)
{
	DesktopAgnosticVFSTrashGIO * self;
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_TRASH_GIO, DesktopAgnosticVFSTrashGIO);
#line 27 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (self->priv->trash);
#line 28 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	_g_object_unref0 (self->priv->monitor);
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	G_OBJECT_CLASS (desktop_agnostic_vfs_trash_gio_parent_class)->finalize (obj);
#line 730 "vfs-trash-impl-gio.c"
}

static GType
desktop_agnostic_vfs_trash_gio_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSTrashGIOClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_trash_gio_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSTrashGIO), 0, (GInstanceInitFunc) desktop_agnostic_vfs_trash_gio_instance_init, NULL };
	static const GInterfaceInfo desktop_agnostic_vfs_trash_info = { (GInterfaceInitFunc) desktop_agnostic_vfs_trash_gio_desktop_agnostic_vfs_trash_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType desktop_agnostic_vfs_trash_gio_type_id;
	desktop_agnostic_vfs_trash_gio_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSTrashGIO", &g_define_type_info, 0);
	g_type_add_interface_static (desktop_agnostic_vfs_trash_gio_type_id, DESKTOP_AGNOSTIC_VFS_TYPE_TRASH, &desktop_agnostic_vfs_trash_info);
	DesktopAgnosticVFSTrashGIO_private_offset = g_type_add_instance_private (desktop_agnostic_vfs_trash_gio_type_id, sizeof (DesktopAgnosticVFSTrashGIOPrivate));
	return desktop_agnostic_vfs_trash_gio_type_id;
}

GType
desktop_agnostic_vfs_trash_gio_get_type (void)
{
	static volatile gsize desktop_agnostic_vfs_trash_gio_type_id__once = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_trash_gio_type_id__once)) {
		GType desktop_agnostic_vfs_trash_gio_type_id;
		desktop_agnostic_vfs_trash_gio_type_id = desktop_agnostic_vfs_trash_gio_get_type_once ();
		g_once_init_leave (&desktop_agnostic_vfs_trash_gio_type_id__once, desktop_agnostic_vfs_trash_gio_type_id);
	}
	return desktop_agnostic_vfs_trash_gio_type_id__once;
}

static void
_vala_desktop_agnostic_vfs_trash_gio_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	DesktopAgnosticVFSTrashGIO * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_TRASH_GIO, DesktopAgnosticVFSTrashGIO);
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
	switch (property_id) {
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		case DESKTOP_AGNOSTIC_VFS_TRASH_GIO_FILE_COUNT_PROPERTY:
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		g_value_set_uint (value, desktop_agnostic_vfs_trash_get_file_count ((DesktopAgnosticVFSTrash*) self));
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		break;
#line 773 "vfs-trash-impl-gio.c"
		default:
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/tmp/B.jz_j4l8d/BUILD/libdesktop-agnostic-0.3.94/libdesktop-agnostic/vfs-trash-impl-gio.vala"
		break;
#line 779 "vfs-trash-impl-gio.c"
	}
}

